unit UnitDataGraph;

interface

uses
   Windows, SysUtils, Dialogs,
   UnitFunc, UnitFuncCurve, UnitData, UnitGraph, UnitClipping ;

var
   ScrX, ScrY : integer ;  // ʃTCY(hbg)
   CenX, CenY : integer ;  // ʒ_(hbg)
   mm_dot : double ;       // mmhbgWϊW
   WndX1, WndY1 : double ; // ʍ_(mm)
   WndX2, WndY2 : double ; // ʉE_(mm)
   CData : TDataClass ;
   gp : TGraphClass ;

   procedure ZInit ;
   procedure Z2D(var ix,iy:integer;x,y:double);
   procedure D2Z(var x,y:double;ix,iy:integer);
   procedure DisplayLayCol1(lay,col:integer;var c,cc:integer);
   procedure DisplayLayCol2(lay,col,ltp,wid:integer;var c,cc,l,li,w:integer;var ww:double);
   procedure DisplayLineSub1(px1,py1,px2,py2:double);
   procedure DisplayLineSub2(l:integer;var i:integer;var d1:double;px1,py1,px2,py2:double);
   procedure DisplayPolygon(n:integer;pt:array of TPointD);
   procedure DisplayPolygon2(t:TMatrix);
   procedure DisplayPolygon3(rgb,alpha:integer;t:TMatrix);
   procedure DisplayPolygon4(rgb1,rgb2,alpha:integer;ang:double;t:TMatrix);
   procedure DisplayPolygon5(rgb1,rgb2,alpha:integer;t:TMatrix);
   procedure DisplayPolygon6(rgb1,rgb2,alpha:integer;hx,hy:double;t:TMatrix);
   procedure DisplayPolygon7(fn:string;t:TMatrix);
   procedure DisplayTenMarker(lay,col,mc:integer;px,py,an,sc:double);
   procedure DisplayLine(lay,col,ltp,wid:integer;px1,py1,px2,py2:double);
   procedure DisplayTLines(lay,col,ltp,wid:integer) ;
   procedure DisplayHArLines(n,lay,col,ltp,wid:integer;t:TMatrix) ;
   procedure DisplayLines(lay,col,ltp,wid,num:integer;vx,vy:array of double;t:TMatrix);
   procedure DisplayCircle(lay,col,ltp,wid,sp:integer;px,py,pr:double;t:TMatrix);
   procedure DisplayArc(lay,col,ltp,wid,sp,dir:integer;px,py,pr,sa,ea:double;t:TMatrix);
   procedure DisplayEllipse(lay,col,ltp,wid,sp:integer;px,py,rx,ry,ra:double;t:TMatrix);
   procedure DisplayEllipseArc(lay,col,ltp,wid,sp,dir:integer;px,py,rx,ry,ra,sa,ea:double;t:TMatrix);
   procedure DisplayText(lay,col,fon,bp,dir:integer;px,py,th,tw,ts,an,sl:double;st:string;t:TMatrix);
   procedure DisplayBezier(lay,col,ltp,wid,sp,num:integer;vx,vy:array of double;t:TMatrix);
   procedure DisplayBspline(lay,col,ltp,wid,oc,sp,num:integer;vx,vy:array of double;t:TMatrix);
   procedure DisplaySpline(lay,col,ltp,wid,stp,oc,sp,num:integer;av:double;vx,vy:array of double;t:TMatrix);
   procedure DisplayClothoid(lay,col,ltp,wid,dir,sp:integer;bx,by,av,an,l1,l2:double;t:TMatrix);
   procedure DisplayArrow(lay,col,ac:integer;px,py,an,sc:double);
   procedure DisplayImage(lay,alpha:integer;px,py,sx,sy,an:double;fn:string);
   procedure DisplayDocument(lay,bp,dir:integer;px,py,pd,pw,ps,pl,an:double;st:string;t:TMatrix);
   procedure DisplayTable(lay,bp,co1,ro1,co2,ro2,lco,llt,lwd,cc1,fl1,cc2,fl2,tco,fnt:integer; px,py,pg,ps:double;cw,rh:array of double;al:array of Integer; st,ca:TStrGrid;t:TMatrix);
   procedure DisplayDimLine(lay,col,ltp,wid,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
   procedure DisplayDimArc(lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
   procedure DisplayDimAngle(lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
   procedure DisplayDimRadius(lay,col,ltp,wid,fl,ar1,ar2,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, arx,ary,arr, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
   procedure DisplayDimDiameter(lay,col,ltp,wid,fl,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
   procedure DisplayDimLeader(lay,col,ltp,wid,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double; arr, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
   procedure DisplayDimBalloon(lay,col,ltp,wid,sp,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double; cx,cy,cr, arr, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
   procedure DisplayHatch1(lay,cf,col,oid,num,hln:integer;iid:array of integer;hl:array of THatchLine;t:TMatrix);
   procedure DisplayHatch2(lay,cf,col,oid,num:integer;iid:array of integer;t:TMatrix);
   procedure DisplayHatch5(lay,cf,col,al,oid,num:integer;iid:array of integer;t:TMatrix);
   procedure DisplayHatch6(lay,cf,col1,col2,al,gtp:integer;an,hx,hy:double;oid,num:integer;iid:array of integer;t:TMatrix);
   procedure DisplayHatch7(lay,cf,col:integer;fn:string;oid,num:integer;iid:array of integer;t:TMatrix);
   procedure DisplaySymbolZukei(lay,cf,col:integer;nam:string;px,py,an,sc:double;t:TMatrix);
   procedure DisplayAllData ;

implementation

// ֘Aeϐ̏
//    in ScrX,ScrY ;
procedure ZInit ;
var
   mx,my : double ;
begin
   mx := (ScrX - 4)/CData.zp.x ;
   my := (ScrY - 4)/CData.zp.y ;
   if (mx < my) then
      mm_dot := mx
   else
      mm_dot := my ;

   CenX := ScrX div 2;    // ʒ
   CenY := ScrY div 2;

   // ʍ_
   WndX1 := CData.zp.x/2.0 + (0        - CenX)/mm_dot ;
   WndY1 := CData.zp.y/2.0 - ((ScrY-1) - CenY)/mm_dot ;
   // ʉE_
   WndX2 := CData.zp.x/2.0 + ((ScrX-1) - CenX)/mm_dot ;
   WndY2 := CData.zp.y/2.0 - (0        - CenY)/mm_dot ;
end;

// pmmWʃhbgW
procedure Z2D(var ix,iy:integer;x,y:double);
begin
   ix := Trunc( (x - WndX1)*mm_dot) ;
   iy := Trunc(-(y - WndY2)*mm_dot) ;
end;

// ʃhbgWpmmW
procedure D2Z(var x,y:double;ix,iy:integer);
begin
   x := WndX1 + ix/mm_dot ;
   y := WndY2 - iy/mm_dot ;
end;

// C̕\E\`FbN
//    lay : C(1-256)
function CheckLayDisp(lay:integer) : Boolean ;
var
   idx : integer ;
begin
   Result := False ;
   idx := CData.GetLayerIdx(lay);
   if (idx > -1) then begin
      if (CData.zLay[idx].Lflag <> 0) then
         Result := True ;
   end;
end;

// F̕\ETu
// (in)
//    lay: C(1-256)
//    col: F@(0,1-256) }CiXlF}CiXRGBl
// (out)
//    c : F   (1-256)
//    cc: RGBF
procedure DisplayLayCol1(lay,col:integer;var c,cc:integer);
var
   idx : integer ;
begin
   if (col >= 0) then begin
      c := col ;
      if (c = 0) then begin
         idx := CData.GetLayerIdx(lay);
         if (idx > -1) then
            c := CData.zLay[idx].Color
         else begin
            idx := CData.GetLayerIdx(1);
            if (idx > -1) then
               c := CData.zLay[idx].Color
         end;
      end;
      idx := CData.GetColorIdx(c);
      if (idx = -1) then begin
         idx := CData.GetColorIdx(1);
         if (idx = -1) then idx := 0;
      end;
      cc := RGB(CData.zCol[idx].Red,CData.zCol[idx].Green,CData.zCol[idx].Blue);
      gp.G_SetPen(cc);
   end
   else begin
      cc := -col ;
      gp.G_SetPen(cc);
   end;
end;

// FEE̕\ETu
// (in)
//    lay: C(1-256)
//    col: F@(0,1-256) -1:w肵Ȃ
//    ltp: (0,1-32)  -1:w肵Ȃ
//    wid: (0,1-16)  -1:w肵Ȃ
// (out)
//    c : F   (1-256)
//    cc: RGBF
//    l :  (1-32)
//    li: index (0-)
//    w :  (1-16)
//    ww:  [dot]
procedure DisplayLayCol2(lay,col,ltp,wid:integer;var c,cc,l,li,w:integer;var ww:double);
var
   idx : integer ;
begin
   DisplayLayCol1(lay,col,c,cc);    // F
   idx := 0;
   li  := 0;
   if (l = 0)or(w = 0) then begin
      idx := CData.GetLayerIdx(lay);
      if (idx = -1) then begin
         idx := CData.GetLayerIdx(1);
         if (idx = -1) then idx := 0;
      end;
   end;
   if (ltp >= 0) then begin
      l := ltp ;
      if (l = 0) then l := CData.zLay[idx].Ltype ;
      // ۂ̐̕`́ADisplayLineSub2()ōs
      li := CData.GetLtypeIdx(l);
      if (li = -1) then begin
         li := CData.GetLtypeIdx(1);
         if (li = -1) then li := 0;
      end;
   end;
   if (wid >= 0) then begin
      w := wid ;
      if (w = 0) then w := CData.zLay[idx].Width ;
      idx := CData.GetWidthIdx(w);
      if (idx = -1) then begin
         idx := CData.GetWidthIdx(1);
         if (idx = -1) then idx := 0;
      end;
      ww := CData.zWid[idx].Width * mm_dot ;
      if (ww <   1.0) then ww :=   1.0 ;
      if (ww > 500.0) then ww := 500.0 ;
      gp.G_SetWidth(Round(ww));
   end;
end;

// ̕\ETuPF
//    px1,py1 : n_[mm]
//    px2,py2 : I_[mm]
//    FE͊Ɏw肵Ă鎖
procedure DisplayLineSub1(px1,py1,px2,py2:double);
var
   x1,y1,x2,y2 : integer ;
begin
   if (ClipLine(px1,py1,px2,py2, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   Z2D(x1,y1, px1,py1);
   Z2D(x2,y2, px2,py2);
   gp.G_Line(x1,y1,x2,y2);
end;

// ̕\ETuQFw
//    l : index(0-)
//    i : JnZOgԍ(IXV)
//    d1: Jnsb`@@(IXV)
//    px1,py1 : n_[mm]
//    px2,py2 : I_[mm]
//    FE͊Ɏw肵Ă鎖
procedure DisplayLineSub2(l:integer;var i:integer;var d1:double;px1,py1,px2,py2:double);
var
   x1,y1,x2,y2 : integer ;
   a,sa,ca,d,p,wx1,wy1,wx2,wy2 : double ;
   fl : Boolean ;
begin
   if (ClipLine(px1,py1,px2,py2, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   a := Angle(px2-px1, py2-py1);
   d := Dist(px1,py1, px2,py2);
   ca:= Cos(a);
   sa:= Sin(a);
   wx1:= px1 ;
   wy1:= py1 ;
   fl := True ;
   while(fl) do begin
   	p := CData.zLtp[l].Pitch[i] - d1 ;
      if (p > d) then p := d ;
      wx2 := wx1 + p*ca ;
      wy2 := wy1 + p*sa ;
      if ((i mod 2) = 0) then begin
         Z2D(x1,y1, wx1,wy1);
         Z2D(x2,y2, wx2,wy2);
         gp.G_Line(x1,y1,x2,y2);
      end;
      wx1 := wx2 ;
      wy1 := wy2 ;
      d := d - p ;
      if (d <= LIMIT8) then begin
      	fl := False ;
      	d1 := d1 + p ;
      end
      else begin
     		d1 := 0.0 ;
         Inc(i);
         if (i >= CData.zLtp[l].Segment) then i:=0;
      end;
   end;
end;

// |S̕\
//    n  : _
//    pt : _W[mm]
//    F͊Ɏw肵Ă鎖
//    ݁ANbsO͍sĂ܂̂Œ
procedure DisplayPolygon(n:integer;pt:array of TPointD);
begin
   gp.PoArClear ;
   gp.PoArSet1(1);
   gp.PoArSet2(0,n,WndX1,WndY2,mm_dot,pt);
   gp.G_Polygon(0);
   gp.PoArClear ;
end;

// |S̕\Q
//    zHAr,zHArN ̗̈hׂ܂
//    F͊Ɏw肵Ă鎖
procedure DisplayPolygon2(t:TMatrix) ;
var
   i : integer ;
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
begin
   with CData do begin
      if (zHArN = 0) then exit ;
      if (zHAr[0].an <= 2) then exit ;
      // O`̍őEŏo
      x1 := zHAr[0].a[0].x ;
      y1 := zHAr[0].a[0].y ;
      x2 := x1 ;
      y2 := y1 ;
      for i:=1 to CData.zHAr[0].an-1 do begin
         if (x1 > zHAr[0].a[i].x) then x1 := zHAr[0].a[i].x;
         if (y1 > zHAr[0].a[i].y) then y1 := zHAr[0].a[i].y;
         if (x2 < zHAr[0].a[i].x) then x2 := zHAr[0].a[i].x;
         if (y2 < zHAr[0].a[i].y) then y2 := zHAr[0].a[i].y;
      end;
      x3 := x2 ;
      y3 := y1 ;
      x4 := x1 ;
      y4 := y2 ;
      //NbsO`FbN
      MtxXY(x1,y1, x1,y1, t);
      MtxXY(x2,y2, x2,y2, t);
      MtxXY(x3,y3, x3,y3, t);
      MtxXY(x4,y4, x4,y4, t);
      if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

      gp.PoArClear ;
      gp.PoArSet1(zHArN);
      for i:=0 to zHArN-1 do begin
         gp.PoArSet3(i,zHAr[i].an, WndX1,WndY2,mm_dot, zHAr[i].a, t);
      end;
   end;
   gp.G_PolygonA ;
   gp.PoArClear ;
end;

// |S̕\R@ߓh
//    zHAr,zHArN ̗̈hׂ܂
//    Fw肪قȂ邾Ł@|S̕\QƂقړł
procedure DisplayPolygon3(rgb,alpha:integer;t:TMatrix);
var
   i : integer ;
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
begin
   with CData do begin
      if (zHArN = 0) then exit ;
      if (zHAr[0].an <= 2) then exit ;
      // O`̍őEŏo
      x1 := zHAr[0].a[0].x ;
      y1 := zHAr[0].a[0].y ;
      x2 := x1 ;
      y2 := y1 ;
      for i:=1 to CData.zHAr[0].an-1 do begin
         if (x1 > zHAr[0].a[i].x) then x1 := zHAr[0].a[i].x;
         if (y1 > zHAr[0].a[i].y) then y1 := zHAr[0].a[i].y;
         if (x2 < zHAr[0].a[i].x) then x2 := zHAr[0].a[i].x;
         if (y2 < zHAr[0].a[i].y) then y2 := zHAr[0].a[i].y;
      end;
      x3 := x2 ;
      y3 := y1 ;
      x4 := x1 ;
      y4 := y2 ;
      //NbsO`FbN
      MtxXY(x1,y1, x1,y1, t);
      MtxXY(x2,y2, x2,y2, t);
      MtxXY(x3,y3, x3,y3, t);
      MtxXY(x4,y4, x4,y4, t);
      if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

      gp.PoArClear ;
      gp.PoArSet1(zHArN);
      for i:=0 to zHArN-1 do begin
         gp.PoArSet3(i,zHAr[i].an, WndX1,WndY2,mm_dot, zHAr[i].a, t);
      end;
   end;
   gp.G_PolygonA(rgb,alpha) ; // Ⴂ܂
   gp.PoArClear ;
end;

// |S̕\S@`Of[V
//    zHAr,zHArN ̗̈hׂ܂
//    Fw肪قȂ邾Ł@|S̕\QƂقړł
procedure DisplayPolygon4(rgb1,rgb2,alpha:integer;ang:double;t:TMatrix);
var
   i : integer ;
   x1,y1,x2,y2,x3,y3,x4,y4,cx,cy,xx,yy : double ;
   w1,w2,w3,w4,w5 : double ;
begin
   with CData do begin
      if (zHArN = 0) then exit ;
      if (zHAr[0].an <= 2) then exit ;
      // O`̍őEŏo
      x1 := zHAr[0].a[0].x ;
      y1 := zHAr[0].a[0].y ;
      x2 := x1 ;
      y2 := y1 ;
      for i:=1 to CData.zHAr[0].an-1 do begin
         if (x1 > zHAr[0].a[i].x) then x1 := zHAr[0].a[i].x;
         if (y1 > zHAr[0].a[i].y) then y1 := zHAr[0].a[i].y;
         if (x2 < zHAr[0].a[i].x) then x2 := zHAr[0].a[i].x;
         if (y2 < zHAr[0].a[i].y) then y2 := zHAr[0].a[i].y;
      end;
      cx := (x1+x2)/2.0 ;
      cy := (y1+y2)/2.0 ;
      x3 := x2 ;
      y3 := y1 ;
      x4 := x1 ;
      y4 := y2 ;
      //NbsO`FbN
      MtxXY(x1,y1, x1,y1, t);
      MtxXY(x2,y2, x2,y2, t);
      MtxXY(x3,y3, x3,y3, t);
      MtxXY(x4,y4, x4,y4, t);
      if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

      MtxXY(w1,w2, cx,cy, t);
      w3 := cx + 10.0*Cos(ang/180.0*Pi);
      w4 := cy + 10.0*Sin(ang/180.0*Pi);
      MtxXY(w3,w4, w3,w4, t);
      w5 := Angle(w3-w1,w4-w2);
      x1 := zHAr[0].a[0].x ;
      y1 := zHAr[0].a[0].y ;
      MtxXY(w3,w4, x1,y1, t);
      Rev(x1,y1, w3,w4, w1,w2, -w5);
      x2 := x1 ;
      y2 := y1 ;
      for i:=1 to CData.zHAr[0].an-1 do begin
         w3 := zHAr[0].a[i].x;
         w4 := zHAr[0].a[i].y;
         MtxXY(w3,w4, w3,w4, t);
         Rev(xx,yy, w3,w4, w1,w2, -w5);
         if (x1 > xx) then x1 := xx;
         if (y1 > yy) then y1 := yy;
         if (x2 < xx) then x2 := xx;
         if (y2 < yy) then y2 := yy;
      end;
      Rev(w3,w4, x1,w2, w1,w2, w5);
      x3 :=  (w3 - WndX1)*mm_dot ;
      y3 := -(w4 - WndY2)*mm_dot ;
      Rev(w3,w4, x2,w2, w1,w2, w5);
      x4 :=  (w3 - WndX1)*mm_dot ;
      y4 := -(w4 - WndY2)*mm_dot ;

      gp.PoArClear ;
      gp.PoArSet1(zHArN);
      for i:=0 to zHArN-1 do begin
         gp.PoArSet3(i,zHAr[i].an, WndX1,WndY2,mm_dot, zHAr[i].a, t);
      end;
   end;
   gp.G_PolygonA(rgb1,rgb2,alpha,x3,y3,x4,y4) ;
   gp.PoArClear ;
end;

// |S̕\T@~`Of[Vi˓_Sj
//    zHAr,zHArN ̗̈hׂ܂
//    Fw肪قȂ邾Ł@|S̕\QƂقړł
procedure DisplayPolygon5(rgb1,rgb2,alpha:integer;t:TMatrix);
var
   i : integer ;
   x1,y1,x2,y2,x3,y3,x4,y4,xx,yy : double ;
   w1,w2,w3,w4 : double ;
begin
   with CData do begin
      if (zHArN = 0) then exit ;
      if (zHAr[0].an <= 2) then exit ;
      // O`̍őEŏo
      x1 := zHAr[0].a[0].x ;
      y1 := zHAr[0].a[0].y ;
      x2 := x1 ;
      y2 := y1 ;
      for i:=1 to CData.zHAr[0].an-1 do begin
         if (x1 > zHAr[0].a[i].x) then x1 := zHAr[0].a[i].x;
         if (y1 > zHAr[0].a[i].y) then y1 := zHAr[0].a[i].y;
         if (x2 < zHAr[0].a[i].x) then x2 := zHAr[0].a[i].x;
         if (y2 < zHAr[0].a[i].y) then y2 := zHAr[0].a[i].y;
      end;
      x3 := x2 ;
      y3 := y1 ;
      x4 := x1 ;
      y4 := y2 ;
      //NbsO`FbN
      MtxXY(x1,y1, x1,y1, t);
      MtxXY(x2,y2, x2,y2, t);
      MtxXY(x3,y3, x3,y3, t);
      MtxXY(x4,y4, x4,y4, t);
      if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

      x1 := zHAr[0].a[0].x ;
      y1 := zHAr[0].a[0].y ;
      MtxXY(x1,y1, x1,y1, t);
      x2 := x1 ;
      y2 := y1 ;
      for i:=1 to CData.zHAr[0].an-1 do begin
         xx := zHAr[0].a[i].x;
         yy := zHAr[0].a[i].y;
         MtxXY(xx,yy, xx,yy, t);
         if (x1 > xx) then x1 := xx;
         if (y1 > yy) then y1 := yy;
         if (x2 < xx) then x2 := xx;
         if (y2 < yy) then y2 := yy;
      end;
      w1 := (x1+x2)/2.0;
      w2 := (y1+y2)/2.0;
      w3 := (x2-x1)/2.0*Sqrt(2.0) ;
      w4 := (y2-y1)/2.0*Sqrt(2.0) ;

      x1 :=  (w1 - WndX1)*mm_dot ;
      y1 := -(w2 - WndY2)*mm_dot ;
      x2 :=  (w1 - WndX1)*mm_dot ;
      y2 := -(w2 - WndY2)*mm_dot ;
      x3 := w3*mm_dot ;
      y3 := w4*mm_dot ;

      gp.PoArClear ;
      gp.PoArSet1(zHArN);
      for i:=0 to zHArN-1 do begin
         gp.PoArSet3(i,zHAr[i].an, WndX1,WndY2,mm_dot, zHAr[i].a, t);
      end;
   end;
   gp.G_PolygonA(rgb1,rgb2,alpha,x1,y1,x2,y2,x3,y3) ;
   gp.PoArClear ;
end;

// |S̕\U@~`Of[Vi˓_CӁj
//    zHAr,zHArN ̗̈hׂ܂
//    Fw肪قȂ邾Ł@|S̕\QƂقړł
procedure DisplayPolygon6(rgb1,rgb2,alpha:integer;hx,hy:double;t:TMatrix);
var
   i : integer ;
   x1,y1,x2,y2,x3,y3,x4,y4,xx,yy : double ;
   w1,w2,w3,w4 : double ;
begin
   with CData do begin
      if (zHArN = 0) then exit ;
      if (zHAr[0].an <= 2) then exit ;
      // O`̍őEŏo
      x1 := zHAr[0].a[0].x ;
      y1 := zHAr[0].a[0].y ;
      x2 := x1 ;
      y2 := y1 ;
      for i:=1 to CData.zHAr[0].an-1 do begin
         if (x1 > zHAr[0].a[i].x) then x1 := zHAr[0].a[i].x;
         if (y1 > zHAr[0].a[i].y) then y1 := zHAr[0].a[i].y;
         if (x2 < zHAr[0].a[i].x) then x2 := zHAr[0].a[i].x;
         if (y2 < zHAr[0].a[i].y) then y2 := zHAr[0].a[i].y;
      end;
      x3 := x2 ;
      y3 := y1 ;
      x4 := x1 ;
      y4 := y2 ;
      //NbsO`FbN
      MtxXY(x1,y1, x1,y1, t);
      MtxXY(x2,y2, x2,y2, t);
      MtxXY(x3,y3, x3,y3, t);
      MtxXY(x4,y4, x4,y4, t);
      if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

      x1 := zHAr[0].a[0].x ;
      y1 := zHAr[0].a[0].y ;
      MtxXY(x1,y1, x1,y1, t);
      x2 := x1 ;
      y2 := y1 ;
      for i:=1 to CData.zHAr[0].an-1 do begin
         xx := zHAr[0].a[i].x;
         yy := zHAr[0].a[i].y;
         MtxXY(xx,yy, xx,yy, t);
         if (x1 > xx) then x1 := xx;
         if (y1 > yy) then y1 := yy;
         if (x2 < xx) then x2 := xx;
         if (y2 < yy) then y2 := yy;
      end;
      w1 := (x1+x2)/2.0;
      w2 := (y1+y2)/2.0;
      w3 := (x2-x1)/2.0*Sqrt(2.0) ;
      w4 := (y2-y1)/2.0*Sqrt(2.0) ;

      x1 :=  (w1 - WndX1)*mm_dot ;
      y1 := -(w2 - WndY2)*mm_dot ;
      MtxXY(w1,w2, hx,hy, t);
      x2 :=  (w1 - WndX1)*mm_dot ;
      y2 := -(w2 - WndY2)*mm_dot ;
      x3 := w3*mm_dot ;
      y3 := w4*mm_dot ;

      gp.PoArClear ;
      gp.PoArSet1(zHArN);
      for i:=0 to zHArN-1 do begin
         gp.PoArSet3(i,zHAr[i].an, WndX1,WndY2,mm_dot, zHAr[i].a, t);
      end;
   end;
   gp.G_PolygonA(rgb1,rgb2,alpha,x1,y1,x2,y2,x3,y3) ;
   gp.PoArClear ;
end;

// |S̕\V@摜h
//    zHAr,zHArN ̗̈hׂ܂
//    uVw肪قȂ邾Ł@|S̕\QƂقړł
procedure DisplayPolygon7(fn:string;t:TMatrix);
var
   i : integer ;
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
begin
   with CData do begin
      if (zHArN = 0) then exit ;
      if (zHAr[0].an <= 2) then exit ;
      // O`̍őEŏo
      x1 := zHAr[0].a[0].x ;
      y1 := zHAr[0].a[0].y ;
      x2 := x1 ;
      y2 := y1 ;
      for i:=1 to CData.zHAr[0].an-1 do begin
         if (x1 > zHAr[0].a[i].x) then x1 := zHAr[0].a[i].x;
         if (y1 > zHAr[0].a[i].y) then y1 := zHAr[0].a[i].y;
         if (x2 < zHAr[0].a[i].x) then x2 := zHAr[0].a[i].x;
         if (y2 < zHAr[0].a[i].y) then y2 := zHAr[0].a[i].y;
      end;
      x3 := x2 ;
      y3 := y1 ;
      x4 := x1 ;
      y4 := y2 ;
      //NbsO`FbN
      MtxXY(x1,y1, x1,y1, t);
      MtxXY(x2,y2, x2,y2, t);
      MtxXY(x3,y3, x3,y3, t);
      MtxXY(x4,y4, x4,y4, t);
      if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

      gp.PoArClear ;
      gp.PoArSet1(zHArN);
      for i:=0 to zHArN-1 do begin
         gp.PoArSet3(i,zHAr[i].an, WndX1,WndY2,mm_dot, zHAr[i].a, t);
      end;
   end;
   gp.G_PolygonA(fn) ; // Ⴂ܂
   gp.PoArClear ;
end;

// _}[J̕\
//    an : ]p[rad]
procedure DisplayTenMarker(lay,col,mc:integer;px,py,an,sc:double);
const
   DOT_SIZE = 5 ;    // _}[Jdot̑傫ialj
var
   c,cc : integer ;
   sz : double ;
   w1,w2,w3,w4,w5,w6 : double ;
   x1,y1 : integer ;
   // i1 : integer ;
   e : TMatrix ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // _}[JENbsO`FbN
   if (mc = 3) then begin
      // dot
      sz := DOT_SIZE/mm_dot ;
   end
   else begin
      // dotȊO
      sz := 2.5*sc*Sqrt(2.0) ;
   end;
   if (Clip1xyPoint(px,py,sz,sz, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   DisplayLayCol1(lay,col,c,cc);    // F
   gp.G_SetWidth(1);
   //
   sz := 2.5/2.0*sc ;
   case(mc)of
   1: begin
         // asterisk
         w5 := px ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(30.0/180.0*Pi) ;
         w6 := py+sz*Sin(30.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(210.0/180.0*Pi) ;
         w6 := py+sz*Sin(210.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(150.0/180.0*Pi) ;
         w6 := py+sz*Sin(150.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(330.0/180.0*Pi) ;
         w6 := py+sz*Sin(330.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   2: begin
         // circle
         {
         Z2D(x1,y1, px,py);
         i1 := Trunc(sz*mm_dot);
         gp.G_Circle(x1,y1,i1);
         }
         MtxSetE(e);
         DisplayCircle(lay,col,1,1,72, px,py,sz,e);
      end;
   3: begin
         // dot
         Z2D(x1,y1, px,py);
         gp.G_CircleF(x1,y1,DOT_SIZE);
      end;
   4: begin
         // plus
         w5 := px-sz ;
         w6 := py ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz ;
         w6 := py ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   5: begin
         // square
         w5 := px-sz ;
         w6 := py-sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz ;
         w6 := py-sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz ;
         w6 := py+sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px-sz ;
         w6 := py+sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px-sz ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px-sz ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   6: begin
         // triangle
         sz := 2.5*2.0/3.0*sc ;
         w5 := px+sz*Cos(90.0/180.0*Pi) ;
         w6 := py+sz*Sin(90.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(210.0/180.0*Pi) ;
         w6 := py+sz*Sin(210.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(210.0/180.0*Pi) ;
         w6 := py+sz*Sin(210.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(330.0/180.0*Pi) ;
         w6 := py+sz*Sin(330.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(330.0/180.0*Pi) ;
         w6 := py+sz*Sin(330.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(90.0/180.0*Pi) ;
         w6 := py+sz*Sin(90.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   7: begin
         // X
         w5 := px-sz ;
         w6 := py ;
         Rev(w1,w2, w5,w6, px,py, an+0.25*Pi);
         w5 := px+sz ;
         w6 := py ;
         Rev(w3,w4, w5,w6, px,py, an+0.25*Pi);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an+0.25*Pi);
         w5 := px ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an+0.25*Pi);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   end;
end;

// ̕\
procedure DisplayLine(lay,col,ltp,wid:integer;px1,py1,px2,py2:double);
var
   c,cc,l,li,w, i : integer ;
   ww, d1 : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,li,w,ww);   // FEE
   //
   if (CData.zLtp[li].Segment = 0)
    or(CData.zLtp[li].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[li].SpaceMax * mm_dot < ww ) then begin
      DisplayLineSub1(px1,py1,px2,py2);
   end
   else begin
      i := 0 ;
      d1:= 0.0;
      DisplayLineSub2(li,i,d1, px1,py1,px2,py2);
   end;
end;

// ϊA̕\
procedure DisplayTLines(lay,col,ltp,wid:integer) ;
var
   c,cc,l,li,w, i,j : integer ;
   ww, d1 : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,li,w,ww);   // FEE
   //
   if (CData.zLtp[li].Segment = 0)
    or(CData.zLtp[li].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[li].SpaceMax * mm_dot < ww ) then begin
      for j:=0 to tLnsN-2 do begin
         DisplayLineSub1(tLns[j].x,tLns[j].y, tLns[j+1].x,tLns[j+1].y);
      end;
   end
   else begin
      i := 0 ;
      d1:= 0.0 ;
      for j:=0 to tLnsN-2 do begin
         DisplayLineSub2(li,i,d1, tLns[j].x,tLns[j].y, tLns[j+1].x,tLns[j+1].y);
      end;
   end;

   TransLnsClear ;   // Af[^NA
end;

// nb`Ö}`̕\
procedure DisplayHArLines(n,lay,col,ltp,wid:integer;t:TMatrix) ;
var
   c,cc,l,li,w, i,j : integer ;
   ww, d1, lx1,ly1,lx2,ly2: double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,li,w,ww);   // FEE
   //
   if (CData.zLtp[li].Segment = 0)
    or(CData.zLtp[li].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[li].SpaceMax * mm_dot < ww ) then begin
      MtxXY(lx1,ly1, CData.zHAr[n].a[0].x,CData.zHAr[n].a[0].y, t);
      for j:=1 to CData.zHAr[n].an-1 do begin
         MtxXY(lx2,ly2, CData.zHAr[n].a[j].x,CData.zHAr[n].a[j].y, t);
         DisplayLineSub1(lx1,ly1, lx2,ly2);
         lx1 := lx2 ;
         ly1 := ly2 ;
      end;
   end
   else begin
      i := 0 ;
      d1:= 0.0 ;
      MtxXY(lx1,ly1, CData.zHAr[n].a[0].x,CData.zHAr[n].a[0].y, t);
      for j:=1 to CData.zHAr[n].an-1 do begin
         MtxXY(lx2,ly2, CData.zHAr[n].a[j].x,CData.zHAr[n].a[j].y, t);
         DisplayLineSub2(li,i,d1, lx1,ly1, lx2,ly2);
         lx1 := lx2 ;
         ly1 := ly2 ;
      end;
   end;
end;

// ܐ̕\
procedure DisplayLines(lay,col,ltp,wid,num:integer;vx,vy:array of double;t:TMatrix);
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   TransLinesToLines(num,vx,vy,t);     // ܐA(tLns,tLnsN)
   if (tLnsN = 0) then exit;           // mەsG[

   DisplayTLines(lay,col,ltp,wid);     // A\f[^NA
end;

// ~̕\
procedure DisplayCircle(lay,col,ltp,wid,sp:integer;px,py,pr:double;t:TMatrix);
var
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // ~ENbsO`FbN
   x1 := px-pr;   y1 := py-pr;   MtxXY(x1,y1, x1,y1, t);
   x2 := px+pr;   y2 := py-pr;   MtxXY(x2,y2, x2,y2, t);
   x3 := px+pr;   y3 := py+pr;   MtxXY(x3,y3, x3,y3, t);
   x4 := px-pr;   y4 := py+pr;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   TransCircleToLines(sp,px,py,pr,t);  // ~A(tLns,tLnsN)
   if (tLnsN = 0) then exit;           // mەsG[

   DisplayTLines(lay,col,ltp,wid);     // A\f[^NA
end;

// ~ʂ̕\
procedure DisplayArc(lay,col,ltp,wid,sp,dir:integer;px,py,pr,sa,ea:double;t:TMatrix);
var
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // ~ENbsO`FbN
   x1 := px-pr;   y1 := py-pr;   MtxXY(x1,y1, x1,y1, t);
   x2 := px+pr;   y2 := py-pr;   MtxXY(x2,y2, x2,y2, t);
   x3 := px+pr;   y3 := py+pr;   MtxXY(x3,y3, x3,y3, t);
   x4 := px-pr;   y4 := py+pr;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   TransArcToLines(sp,dir,px,py,pr,sa,ea,t); // ~ʁA(tLns,tLnsN)
   if (tLnsN = 0) then exit;           // mەsG[

   DisplayTLines(lay,col,ltp,wid);     // A\f[^NA
end;

// ȉ~̕\
procedure DisplayEllipse(lay,col,ltp,wid,sp:integer;px,py,rx,ry,ra:double;t:TMatrix);
var
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   tt,tr,tr1 : TMatrix ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // ȉ~ENbsO`FbNiQxԂɂȂ܂ȂȂ̂ttɁj
   MtxMove(tr, -px,-py);
   MtxRotD(tr1,ra);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, px,py);
   tr := MtxMult(tr,tr1) ;
   tt := MtxMult(tr,t) ;
   x1 := px-rx;   y1 := py-ry;   MtxXY(x1,y1, x1,y1, tt);
   x2 := px+rx;   y2 := py-ry;   MtxXY(x2,y2, x2,y2, tt);
   x3 := px+rx;   y3 := py+ry;   MtxXY(x3,y3, x3,y3, tt);
   x4 := px-rx;   y4 := py+ry;   MtxXY(x4,y4, x4,y4, tt);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   TransEllipseToLines(sp,px,py,rx,ry,ra,t); // ȉ~A(tLns,tLnsN)
   if (tLnsN = 0) then exit;           // mەsG[

   DisplayTLines(lay,col,ltp,wid);     // A\f[^NA
end;

// ȉ~ʂ̕\
procedure DisplayEllipseArc(lay,col,ltp,wid,sp,dir:integer;px,py,rx,ry,ra,sa,ea:double;t:TMatrix);
var
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   tt,tr,tr1 : TMatrix ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // ȉ~ENbsO`FbNiQxԂɂȂ܂ȂȂ̂ttɁj
   MtxMove(tr, -px,-py);
   MtxRotD(tr1,ra);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, px,py);
   tr := MtxMult(tr,tr1) ;
   tt := MtxMult(tr,t) ;
   x1 := px-rx;   y1 := py-ry;   MtxXY(x1,y1, x1,y1, tt);
   x2 := px+rx;   y2 := py-ry;   MtxXY(x2,y2, x2,y2, tt);
   x3 := px+rx;   y3 := py+ry;   MtxXY(x3,y3, x3,y3, tt);
   x4 := px-rx;   y4 := py+ry;   MtxXY(x4,y4, x4,y4, tt);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   TransEllipseArcToLines(sp,dir,px,py,rx,ry,ra,sa,ea,t);   // ȉ~ʁA(tLns,tLnsN)
   if (tLnsN = 0) then exit;           // mەsG[

   DisplayTLines(lay,col,ltp,wid);     // A\f[^NA
end;

// ̕\
procedure DisplayText(lay,col,fon,bp,dir:integer;px,py,th,tw,ts,an,sl:double;st:string;t:TMatrix);
var
   tr,tr1 : TMatrix ;
   dx,dy,x1,y1,x2,y2,x3,y3,x4,y4,ma,mx,my,w1,w2,w3,w4,w5,mh1,mw1,mh2,mw2 : double ;
   idx,c,cc,at,l1,i,ix,iy : integer ;
   fo,s1 : string ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   l1 := Length(st);    // 
   if (l1 = 0) then exit ;

   // _ɍ킹
   case(bp)of
   2: begin   // 2:
         dx := -tw/2.0 ;
         dy := 0.0 ;
      end;
   3: begin   // 3:E
         dx := -tw ;
         dy := 0.0 ;
      end;
   4: begin   // 4:
         dx := 0.0 ;
         dy := -th/2.0 ;
      end;
   5: begin   // 5:
         dx := -tw/2.0 ;
         dy := -th/2.0 ;
      end;
   6: begin   // 6:E
         dx := -tw ;
         dy := -th/2.0 ;
      end;
   7: begin   // 7:
         dx := 0.0 ;
         dy := -th ;
      end;
   8: begin   // 8:
         dx := -tw/2.0 ;
         dy := -th ;
      end;
   9: begin   // 9:E
         dx := -tw ;
         dy := -th ;
      end;
   else begin // 1:
         dx := 0.0 ;
         dy := 0.0 ;
      end;
   end;
   // --- ENbsO`FbN ---
   MtxMove(tr, -px,-py);
   MtxRotD(tr1,an);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, px,py);
   tr := MtxMult(tr,tr1) ;
   t  := MtxMult(tr,t) ;
   x1 := px+dx;      y1 := py+dy;      MtxXY(x1,y1, x1,y1, t);
   x2 := px+dx+tw;   y2 := py+dy;      MtxXY(x2,y2, x2,y2, t);
   x3 := px+dx+tw;   y3 := py+dy+th;   MtxXY(x3,y3, x3,y3, t);
   x4 := px+dx;      y4 := py+dy+th;   MtxXY(x4,y4, x4,y4, t);

   // }ɂό`镶`Aό`Ȃ悤K
   ma := dAngle((x2-x1),(y2-y1));   // ̊px
   mx := Dist(x1,y1, x2,y2);        // ͈͕
   my := Dist(x1,y1, x4,y4);        // ͈͍
   w1 := dAngle((x4-x1),(y4-y1)) - ma ;
   my := Abs(my*Sin(w1/180.0*Pi));  // VE͈͍

   // `͍_Ȃ̂łɍ킹s(tr1)쐬
   case(bp)of
   2: begin   // 2:
         w3 := -mx/2.0 ;
         w4 := my ;
      end;
   3: begin   // 3:E
         w3 := -mx ;
         w4 := my ;
      end;
   4: begin   // 4:
         w3 := 0.0 ;
         w4 := my/2.0 ;
      end;
   5: begin   // 5:
         w3 := -mx/2.0 ;
         w4 := my/2.0 ;
      end;
   6: begin   // 6:E
         w3 := -mx ;
         w4 := my/2.0 ;
      end;
   7: begin   // 7:
         w3 := 0.0 ;
         w4 := 0.0 ;
      end;
   8: begin   // 8:
         w3 := -mx/2.0 ;
         w4 := 0.0 ;
      end;
   9: begin   // 9:E
         w3 := -mx ;
         w4 := 0.0 ;
      end;
   else begin // 1:
         w3 := 0.0 ;
         w4 := my ;
      end;
   end;
   w1 := RevX(w3,w4,0.0,0.0,ma/180.0*Pi);
   w2 := RevY(w3,w4,0.0,0.0,ma/180.0*Pi);
   MtxMove(tr1, w1,w2);
   tr1:= MtxMult(t, tr1) ;
   // ČvZ
   x3 := px+tw;   y3 := py;      MtxXY(x3,y3, x3,y3, tr1);
   x4 := px;      y4 := py;      MtxXY(x4,y4, x4,y4, tr1);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   DisplayLayCol1(lay,col,c,cc);    // F
{
   // g\eXg
   gp.G_SetWidth(1);
   DisplayLineSub1(x1,y1,x2,y2);
   DisplayLineSub1(x2,y2,x3,y3);
   DisplayLineSub1(x3,y3,x4,y4);
   DisplayLineSub1(x4,y4,x1,y1);
}
   at := 0 ;
   if (gp.DisplayMode = 0)and(Abs(sl) > LIMIT8) then at := 2;
   if (fon = 0) then begin
      idx := CData.GetLayerIdx(lay);
      if (idx = -1) then begin
         idx := CData.GetLayerIdx(1);
         if (idx = -1) then idx := 0;
      end;
      fon := CData.zLay[idx].Mfont ;
   end;
   idx := CData.GetFontIdx(fon);
   if (idx = -1) then begin
      idx := CData.GetFontIdx(1);
      if (idx = -1) then idx := 0;
   end;
   fo := CData.zFnt[idx].name ;   // tHg
   s1 := Copy(fo,1,1);
   if (s1 = '@')or(s1 = '') then fo := Copy(fo,2,Length(fo));

   if (dir = 1) then begin
      // 
      w1 := 0.0;
      w2 := gp.G_TextWidth(at,32,32,fo,st);
      mh1:= th ;                       // sϊO̕
      mw1:= tw - (l1-1.0)*ts ;         // sϊÓ͈̕iԊuj
      mh2:= my ;                       // sϊ̕
      mw2:= mx - (l1-1.0)*ts*mx/tw ;   // sΐ͈̕iԊuj
      w5 := gp.G_TextWidth(at,100,100,fo,st);
      w4 := 100.0*mw1/w5;
      w5 := 100.0*mw2/w5;
      for i:=1 to l1 do begin
         s1 := Copy(st,i,1);
         w3 := gp.G_TextWidth(at,32,32,fo,s1) / w2 ;
         // 1Pʂ̃NbsO`FbN
         x1 := px+dx+w1;      y1 := py+dy;   MtxXY(x1,y1, x1,y1, t);
         x2 := px+dx+w1+w4;   y2 := py+dy;   MtxXY(x2,y2, x2,y2, t);
         x3 := px+w1+w4;      y3 := py;      MtxXY(x3,y3, x3,y3, tr1);
         x4 := px+w1;         y4 := py;      MtxXY(x4,y4, x4,y4, tr1);
         if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) < 2) then begin
            x1 := px + w1 ;
            y1 := py ;
            MtxXY(x1,y1, x1,y1, tr1);
            Z2D(ix,iy, x1,y1);
            gp.G_Text1(at,ix,iy,Round(mh2*mm_dot),Round(w5*mm_dot),ma,sl,fo,s1);
         end;
         w1 := w1 + mw1*w3 + ts;
      end;
   end
   else begin
      // c
      w1 := 0.0;
      w2 := 0.0;
      w5 := 0.0;
      for i:=1 to l1 do begin
         s1 := Copy(st,i,1);
         if (HanCheck(s1))or(MojiRotCheck(s1)) then begin
            // p,Sp]
            w2 := w2 + gp.G_TextWidth(0,32,32,fo,s1);
            w5 := w5 + gp.G_TextWidth(at,100,100,fo,s1);
         end
         else begin
            // Sp
            w2 := w2 + 32.0 ;
            w5 := w5 + 100.0;
         end;
      end;
      mh1:= th - (l1-1.0)*ts ;         // sϊÓ͈̕iԊuj
    //mw1:= tw ;                       // sϊO͈̕
      mh2:= my - (l1-1.0)*ts*my/th ;   // sΐ͈̕iԊuj
      mw2:= mx ;                       // sϊ͈̕
      w5 := 100.0*mh2/w5;
      dx := px + dx ;
      dy := py + dy ;
      MtxXY(dx,dy, dx,dy, t);
      for i:=1 to l1 do begin
         s1 := Copy(st,i,1);
         if (HanCheck(s1))or(MojiRotCheck(s1)) then begin
            // p,Sp]
            w3 := gp.G_TextWidth(0,32,32,fo,s1) / w2 ;
         end
         else begin
            // Sp
            w3 := 32.0 / w2 ;
         end;
         // 1Pʂ̃NbsO`FbN
         dRev(x1,y1,dx    ,dy+my-w1       ,dx,dy,ma);
         dRev(x2,y2,dx    ,dy+my-w1-mh2*w3,dx,dy,ma);
         dRev(x3,y3,dx+mw2,dy+my-w1-mh2*w3,dx,dy,ma);
         dRev(x4,y4,dx+mw2,dy+my-w1       ,dx,dy,ma);
         if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) < 2) then begin
            if (HanCheck(s1))or(MojiRotCheck(s1)) then begin
               // p,Sp]
               dRev(x2,y2,dx+mw2,dy+my-w1,dx,dy,ma);
               Z2D(ix,iy, x2,y2);
               if not(MojiRRotCheck(s1)) then begin
                  gp.G_Text1(0,ix,iy,Round(mw2*mm_dot),Round(w5*mm_dot),ma-90.0,0.0,fo,s1);
                  // c̔p90]ESpƂԂ̂ŃXg͖
               end
               else begin
                  gp.G_Text1(0,ix,iy,Round(-mw2*mm_dot),Round(w5*mm_dot),ma-90.0,0.0,fo,s1);
                  // cu[vu`v͍E]Kv̂œꏈs܂
               end;
            end
            else begin
               // Sp
               mw1:= 1.0;
               w4 := mw2/2.0 - mw2*gp.G_TextWidth(at,32,32,fo,s1)/32.0/2.0 ;
               if (w4 < 0.0) then begin
                  mw1:= 32.0 / gp.G_TextWidth(at,32,32,fo,s1) ;
                  w4 := 0.0;
               end;
               if (MojiMoveCheck(s1)) then begin
                  w4 := w4 + 0.4*mw2 ;
               end;
               dRev(x2,y2,dx+w4,dy+my-w1,dx,dy,ma);
               Z2D(ix,iy, x2,y2);
               gp.G_Text1(at,ix,iy,Round(w5*mm_dot),Round(mw1*mw2*mm_dot),ma,sl,fo,s1);
            end;
         end;
         w1 := w1 + mh2*w3 + ts*my/th;
      end;
   end;
end;

// xWFȐ̕\
procedure DisplayBezier(lay,col,ltp,wid,sp,num:integer;vx,vy:array of double;t:TMatrix);
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   TransBezierToLines(sp,num,vx,vy,t); // xWFȐA(tLns,tLnsN)
   if (tLnsN = 0) then exit;           // mەsG[

   DisplayTLines(lay,col,ltp,wid);     // A\f[^NA
end;

// aXvCȐ̕\
procedure DisplayBspline(lay,col,ltp,wid,oc,sp,num:integer;vx,vy:array of double;t:TMatrix);
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   TransBsplineToLines(oc,sp,num,vx,vy,t);   // aXvCȐA(tLns,tLnsN)
   if (tLnsN = 0) then exit;           // mەsG[

   DisplayTLines(lay,col,ltp,wid);     // A\f[^NA
end;

// XvCȐ̕\
procedure DisplaySpline(lay,col,ltp,wid,stp,oc,sp,num:integer;av:double;vx,vy:array of double;t:TMatrix);
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   TransSplineToLines(stp,oc,sp,num, av,vx,vy,t);  // XvCȐA(tLns,tLnsN)
   if (tLnsN = 0) then exit;           // mەsG[

   DisplayTLines(lay,col,ltp,wid);     // A\f[^NA
end;

// N\ChȐ̕\
procedure DisplayClothoid(lay,col,ltp,wid,dir,sp:integer;bx,by,av,an,l1,l2:double;t:TMatrix);
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   TransClothoidToLines(dir,sp,bx,by,av,an,l1,l2,t);  // N\ChȐA(tLns,tLnsN)
   if (tLnsN = 0) then exit;           // mەsG[

   DisplayTLines(lay,col,ltp,wid);     // A\f[^NA
end;

// ̕\
//    an : ]p[rad]
procedure DisplayArrow(lay,col,ac:integer;px,py,an,sc:double);
var
   sx,sy : double ;
   c,cc : integer ;
   w1,w2,w3,w4,w5,w6 : double ;
   pt : array of TPointD ;
   i : integer ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // NbsO`FbN
   w1 := px ;
   w2 := py ;
   sx := 2.5*sc ;
   sy := sx ;
   if (ac = 1)or(ac = 6)or(ac = 9)or(ac = 11) then begin
      w1 := px + 7.5/2.0*sc*Cos(an);
      w2 := py + 7.5/2.0*sc*Sin(an);
      sx := 7.5*sc ;
   end
   else if (ac = 8)or(ac = 10) then begin
      sx := 2.5*Sqrt(2.0);
      sy := sx ;
   end;
   if (Clip1xyaPoint(w1,w2,sx,sy,an, WndX1,WndY1,WndX2,WndY2) = 2) then exit;
   //
   DisplayLayCol1(lay,col,c,cc);    // F
   gp.G_SetWidth(1);
   //
   case(ac)of
   1: begin    // blanked arrow
         SetLength(pt,4);
         pt[0].x := px ;
         pt[0].y := py ;
         w5 := px + 7.5 *sc ;
         w6 := py + 1.25*sc ;
         Rev(pt[1].x,pt[1].y, w5,w6, px,py, an);
         w5 := px + 7.5 *sc ;
         w6 := py - 1.25*sc ;
         Rev(pt[2].x,pt[2].y, w5,w6, px,py, an);
         pt[3].x := pt[0].x ;
         pt[3].y := pt[0].y ;
         //
         gp.G_SetPen(Cdata.BackColor);
         DisplayPolygon(3,pt);
         gp.G_SetPen(cc);
         for i:=0 to 2 do
            DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
         pt := nil;
      end;
   2: begin    // blanked box
         SetLength(pt,5);
         w5 := px - 1.25*sc ;
         w6 := py - 1.25*sc ;
         Rev(pt[0].x,pt[0].y, w5,w6, px,py, an);
         w5 := px + 1.25*sc ;
         w6 := py - 1.25*sc ;
         Rev(pt[1].x,pt[1].y, w5,w6, px,py, an);
         w5 := px + 1.25*sc ;
         w6 := py + 1.25*sc ;
         Rev(pt[2].x,pt[2].y, w5,w6, px,py, an);
         w5 := px - 1.25*sc ;
         w6 := py + 1.25*sc ;
         Rev(pt[3].x,pt[3].y, w5,w6, px,py, an);
         pt[4].x := pt[0].x ;
         pt[4].y := pt[0].y ;
         //
         gp.G_SetPen(Cdata.BackColor);
         DisplayPolygon(4,pt);
         gp.G_SetPen(cc);
         for i:=0 to 3 do
            DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
         pt := nil;
      end;
   3: begin    // blanked dot
         SetLength(pt,25);
         w1 := 2.0*Pi/24 ;
         for i:=0 to 24 do begin
            pt[i].x := px + 1.25*sc*Cos(i*w1);
            pt[i].y := py + 1.25*sc*Sin(i*w1);
         end;
         //
         gp.G_SetPen(Cdata.BackColor);
         DisplayPolygon(23,pt);
         gp.G_SetPen(cc);
         for i:=0 to 23 do
            DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
         pt := nil;
      end;
   4: begin    // dimension origin
         SetLength(pt,25);
         w1 := 2.0*Pi/24 ;
         for i:=0 to 24 do begin
            pt[i].x := px + 1.25*sc*Cos(i*w1);
            pt[i].y := py + 1.25*sc*Sin(i*w1);
         end;
         //
         for i:=0 to 23 do
            DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
         pt := nil;
      end;
   5: begin    // filled box
         SetLength(pt,5);
         w5 := px - 1.25*sc ;
         w6 := py - 1.25*sc ;
         Rev(pt[0].x,pt[0].y, w5,w6, px,py, an);
         w5 := px + 1.25*sc ;
         w6 := py - 1.25*sc ;
         Rev(pt[1].x,pt[1].y, w5,w6, px,py, an);
         w5 := px + 1.25*sc ;
         w6 := py + 1.25*sc ;
         Rev(pt[2].x,pt[2].y, w5,w6, px,py, an);
         w5 := px - 1.25*sc ;
         w6 := py + 1.25*sc ;
         Rev(pt[3].x,pt[3].y, w5,w6, px,py, an);
         pt[4].x := pt[0].x ;
         pt[4].y := pt[0].y ;
         //
         DisplayPolygon(4,pt);
         for i:=0 to 3 do
            DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
         pt := nil;
      end;
   6: begin    // filled arrow
         SetLength(pt,4);
         pt[0].x := px ;
         pt[0].y := py ;
         w5 := px + 7.5 *sc ;
         w6 := py + 1.25*sc ;
         Rev(pt[1].x,pt[1].y, w5,w6, px,py, an);
         w5 := px + 7.5 *sc ;
         w6 := py - 1.25*sc ;
         Rev(pt[2].x,pt[2].y, w5,w6, px,py, an);
         pt[3].x := pt[0].x ;
         pt[3].y := pt[0].y ;
         //
         DisplayPolygon(3,pt);
         for i:=0 to 2 do
            DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
         pt := nil;
      end;
   7: begin    // filled dot
         SetLength(pt,25);
         w1 := 2.0*Pi/24 ;
         for i:=0 to 24 do begin
            pt[i].x := px + 1.25*sc*Cos(i*w1);
            pt[i].y := py + 1.25*sc*Sin(i*w1);
         end;
         //
         DisplayPolygon(23,pt);
         for i:=0 to 23 do
            DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
         pt := nil;
      end;
   8: begin    // integral symbol
         SetLength(pt,25);
         w1 := Pi/2.0/12 ;
         for i:=0 to 12 do begin
            w5 := px-sx/2.0 + sx/2.0*Cos(1.5*Pi+i*w1);
            w6 := py        + sx/2.0*Sin(1.5*Pi+i*w1);
            Rev(pt[i].x,pt[i].y, w5,w6, px,py, an);
         end;
         for i:=1 to 12 do begin
            w5 := px+sx/2.0 + sx/2.0*Cos(Pi-i*w1);
            w6 := py        + sx/2.0*Sin(Pi-i*w1);
            Rev(pt[i+12].x,pt[i+12].y, w5,w6, px,py, an);
         end;
         //
         for i:=0 to 23 do
            DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
         pt := nil;
      end;
   9: begin    // open arrow
         w1 := px ;
         w2 := py ;
         w5 := px + 7.5 *sc ;
         w6 := py + 1.25*sc ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2, w3,w4);
         w5 := px + 7.5 *sc ;
         w6 := py - 1.25*sc ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2, w3,w4);
      end;
   10:begin    // slash
         w5 := px - sx/2.0 ;
         w6 := py - sx/2.0 ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px + sx/2.0 ;
         w6 := py + sx/2.0 ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2, w3,w4);
      end;
   11:begin    // unfilled arrow
         SetLength(pt,4);
         pt[0].x := px ;
         pt[0].y := py ;
         w5 := px + 7.5 *sc ;
         w6 := py + 1.25*sc ;
         Rev(pt[1].x,pt[1].y, w5,w6, px,py, an);
         w5 := px + 7.5 *sc ;
         w6 := py - 1.25*sc ;
         Rev(pt[2].x,pt[2].y, w5,w6, px,py, an);
         pt[3].x := pt[0].x ;
         pt[3].y := pt[0].y ;
         //
         for i:=0 to 2 do
            DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
         pt := nil;
      end;
   end;
end;

// 摜̕\
procedure DisplayImage(lay,alpha:integer;px,py,sx,sy,an:double;fn:string);
var
   ex : string ;
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   h,w: integer ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   ex := AnsiLowerCase(ExtractFileExt(fn));
   if not(FileExists(fn))
    or((ex <> '.ico')and(ex <> '.bmp')and(ex <> '.wmf')and(ex <> '.emf')
    and(ex <> '.jpg')and(ex <> '.jpeg')and(ex <> '.png')and(ex <> '.gif')
    and(ex <> '.tif')and(ex <> '.tiff')) then
      exit;

   // NbsO`FbN
   x1 := px;
   y1 := py;
   x2 := px + sx*Cos(an/180.0*Pi);
   y2 := py + sx*Sin(an/180.0*Pi);
   x3 := x2 + sy*Cos((an+90.0)/180.0*Pi);
   y3 := y2 + sy*Sin((an+90.0)/180.0*Pi);
   x4 := px + sy*Cos((an+90.0)/180.0*Pi);
   y4 := py + sy*Sin((an+90.0)/180.0*Pi);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   x1 :=  (x1 - WndX1)*mm_dot ;
   y1 := -(y1 - WndY2)*mm_dot ;
   gp.G_ImageSize(h,w,fn);
   if (h = 0)or(w = 0) then exit ;
   x2 := sx*mm_dot / w ;
   y2 := sy*mm_dot / h ;
   gp.G_Image(x1,y1,x2,y2,an,fn,alpha);
end;

// ͓̕̕\
procedure DisplayDocumentSub(dir,sc,sa,sm,ih,iw:integer;xp,xq,yp,pd:double;sf,st:string;t:TMatrix);
var
   mh,mw,ma : double ;
   x0,y0,x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   mx,my,w1,w2 : double ;
   ix,iy : integer ;
begin
   mh := Int(ih*25.4/pd*100.0)/100.0 ;
   mw := Int(iw*25.4/pd*100.0)/100.0 ;
   if (dir = 1) then
      ma := 0.0
   else
      ma := -0.5*Pi ;
   x0 := xp+xq*Cos(ma); y0 := yp+xq*Sin(ma);

   x1 := x0;      y1 := y0;            MtxXY(x1,y1, x1,y1, t);
   x2 := x0+RevX(mw,0.0, 0.0,0.0,ma);
   y2 := y0+RevY(mw,0.0, 0.0,0.0,ma);  MtxXY(x2,y2, x2,y2, t);
   x3 := x0+RevX(mw,mh , 0.0,0.0,ma);
   y3 := y0+RevY(mw,mh , 0.0,0.0,ma);  MtxXY(x3,y3, x3,y3, t);
   x4 := x0+RevX(0.0,mh, 0.0,0.0,ma);
   y4 := y0+RevY(0.0,mh, 0.0,0.0,ma);  MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   gp.G_SetPen(sc);
{  // g\eXg
   DisplayLineSub1(x1,y1,x2,y2);
   DisplayLineSub1(x2,y2,x3,y3);
   DisplayLineSub1(x3,y3,x4,y4);
   DisplayLineSub1(x4,y4,x1,y1);
}
   // }ɂό`镶`Aό`Ȃ悤K
   ma := dAngle((x2-x1),(y2-y1));   // ̊px
   mx := Dist(x1,y1, x2,y2);        // ͈͕
   my := Dist(x1,y1, x4,y4);        // ͈͍
   w1 := dAngle((x4-x1),(y4-y1)) - ma ;
   my := Abs(my*Sin(w1/180.0*Pi));  // VE͈͍
   // __
   w1 := x1 + RevX(0.0,my, 0.0,0.0, ma/180.0*Pi);
   w2 := y1 + RevY(0.0,my, 0.0,0.0, ma/180.0*Pi);
   Z2D(ix,iy, w1,w2);
   if (HanCheck(st)) then mx := mx*2.0;   // p̏ꍇ͑SpKvȂ̂Ŕ{ɂĂ
   gp.G_Text2(sa,ix,iy,Round(my*mm_dot),Round(mx*mm_dot),sm,ma,sf,st);
end;

// ͂̕\
procedure DisplayDocument(lay,bp,dir:integer;px,py,pd,pw,ps,pl,an:double;st:string;t:TMatrix);
var
   xp,yp,x : double ;
   lx,ly,lc,ll,al : integer ;
   i,j,k,sm,sh,sc,sa : integer ;
   s,ss,sf : string ;
   swa : array of double ;
   sha : array of integer ;
   dx,dy,x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   tr,tr1 : TMatrix ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // sNZEcsNZ擾
   xp := 0.0 ;   // max
   yp := 0.0 ;   // c
   lx := 0 ;   // Ps̉sNZ
   ly := 0 ;   // Ps̕max
   lc := 0 ;   // Ps̕
   ll := 0 ;   // s
   sf := 'lr SVbN';
   sm := DEFAULT_CHARSET ;
   sh := 13 ;
   //sc := 0 ;
   sa := 0 ;
   SetLength(swa,100);  // es̕S[mm] Cfg,^u,Ԋu܂
   SetLength(sha,100);  // es̕MAX[px]
   i := 1 ;
   while (i <= Length(st)) do begin
      s := Copy(st,i,1);
      if (s = '\') then begin
         Inc(i);
         s := Copy(st,i,1);
         if (s = 'A') then begin
            Inc(i);
            s := Copy(st,i,1);
            Case (SInt(s)) of
            1: ;  // 
            2: ;  // 
            3: ;  // E
            end;
         end
         else if (s = 'K') then begin
            ss := '' ;
            while (i < Length(st)) do begin
               Inc(i);
               s := Copy(st,i,1);
               if (s = ';')or(s = '\') then break
               else ss := ss + s ;
            end;
            j := SInt(ss);
            if (j >= 0)and(j <= 1638) then begin
               lx := lx + j ; // Cfg
               j  := gp.G_TextWidth2(sa,sh,sm,sf,'E');
               k  := sh ;
               // cctHggp90X擾œ͕̂
               lx := lx + j ;
               if (ly < k) then ly := k ;
            end;
         end
         else if (s = 'N') then begin
            // s
            x  := Int(lx*25.4/pd*100.0)/100.0 + (lc-1.0)*ps ;
            swa[ll] := x ;
            if (xp < x) then xp := x ;

            if (ly = 0) then begin
               // ͖ŝ݂̏ꍇ
               // j  := gp.G_TextWidth2(sa,sh,sm,sf,'`');
               k  := sh ;
               ly := k ;
            end;
            sha[ll] := ly ;
            yp := yp + Int(ly*25.4/pd*100.0)/100.0 ;

            lx := 0 ;
            ly := 0 ;
            lc := 0 ;
            Inc(ll) ;
            if ((ll mod 100) = 0) then begin
               SetLength(swa,ll+100);
               SetLength(sha,ll+100);
            end;
         end
         else if (s = 'T') then begin
            // TAB
            lx := ((lx div 36) + 1) * 36 ;
         end
         else if (s = 'F') then begin
            ss := '' ;
            while (i < Length(st)) do begin
               Inc(i);
               s := Copy(st,i,1);
               if (s = ';')or(s = '\') then break
               else ss := ss + s ;
            end;
            sf := ss ;
         end
         else if (s = 'M') then begin
            ss := '' ;
            while (i < Length(st)) do begin
               Inc(i);
               s := Copy(st,i,1);
               if (s = ';')or(s = '\') then break
               else ss := ss + s ;
            end;
            j := SInt(ss);
            if (j >= 0)and(j <= 255) then begin
               sm := j ;
            end;
         end
         else if (s = 'H') then begin
            ss := '' ;
            while (i < Length(st)) do begin
               Inc(i);
               s := Copy(st,i,1);
               if (s = ';')or(s = '\') then break
               else ss := ss + s ;
            end;
            j := SInt(ss);
            if (j >= 1)and(j <= 1638) then begin
               sh := j ;
            end;
         end
         else if (s = 'C') then begin
            Inc(i);
            s := Copy(st,i,6);
            i := i + 5 ;
            j := SInt('$'+s);
            if (j >= $000000)and(j <= $ffffff) then begin
               //sc := j ;
            end;
         end
         else if (s = 'B') then sa := sa or 1
         else if (s = 'b') then sa := sa and $fffe
         else if (s = 'I') then sa := sa or 2
         else if (s = 'i') then sa := sa and $fffd
         else if (s = 'U') then sa := sa or 4
         else if (s = 'u') then sa := sa and $fffb
         else if (s = 'S') then sa := sa or 8
         else if (s = 's') then sa := sa and $fff7
         else if (s = 'c') then begin
            sa := 0 ;
         end;
      end
      else begin
         j  := gp.G_TextWidth2(sa,sh,sm,sf,s);
         k  := sh ;
         lx := lx + j ;
         if (ly < k) then ly := k ;
         Inc(lc);
      end;
      Inc(i);
   end;
   if (lc > 0) then begin
      x := Int(lx*25.4/pd*100.0)/100.0 + (lc-1.0)*ps ;
      swa[ll] := x ;
      sha[ll] := ly ;
      yp := yp + Int(ly*25.4/pd*100.0)/100.0 ;
      Inc(ll);
   end;
   yp := yp + (ll-1.0)*pl ;
   if (xp < pw) then xp := pw ;     // ͔͈͕
   if (dir <> 1) then swapD(xp,yp); // c

   // _ɍ킹
   case(bp)of
   2: begin   // 2:
         dx := -xp/2.0 ;
         dy := 0.0 ;
      end;
   3: begin   // 3:E
         dx := -xp ;
         dy := 0.0 ;
      end;
   4: begin   // 4:
         dx := 0.0 ;
         dy := -yp/2.0 ;
      end;
   5: begin   // 5:
         dx := -xp/2.0 ;
         dy := -yp/2.0 ;
      end;
   6: begin   // 6:E
         dx := -xp ;
         dy := -yp/2.0 ;
      end;
   7: begin   // 7:
         dx := 0.0 ;
         dy := -yp ;
      end;
   8: begin   // 8:
         dx := -xp/2.0 ;
         dy := -yp ;
      end;
   9: begin   // 9:E
         dx := -xp ;
         dy := -yp ;
      end;
   else begin // 1:
         dx := 0.0 ;
         dy := 0.0 ;
      end;
   end;
   // --- ͘gNbsO`FbN ---
   MtxMove(tr, -px,-py);
   MtxRotD(tr1,an);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, px,py);
   tr := MtxMult(tr,tr1) ;
   t  := MtxMult(tr,t) ;
   x1 := px+dx;      y1 := py+dy;      MtxXY(x1,y1, x1,y1, t);
   x2 := px+dx+xp;   y2 := py+dy;      MtxXY(x2,y2, x2,y2, t);
   x3 := px+dx+xp;   y3 := py+dy+yp;   MtxXY(x3,y3, x3,y3, t);
   x4 := px+dx;      y4 := py+dy+yp;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

{   // g\eXg
   DisplayLayCol1(lay,0,i,j); // F
   gp.G_SetWidth(1);
   DisplayLineSub1(x1,y1,x2,y2);
   DisplayLineSub1(x2,y2,x3,y3);
   DisplayLineSub1(x3,y3,x4,y4);
   DisplayLineSub1(x4,y4,x1,y1);
}
   // x1,y1́Ax[XC_@c-90]ƍl
   if (dir = 1) then begin
      x1 := px+dx ;
      y1 := py+dy+yp - Int(sha[0]*25.4/pd*100.0)/100.0 ;
      x3 := xp ;
   end
   else begin
      x1 := px+dx+xp - Int(sha[0]*25.4/pd*100.0)/100.0 ;
      y1 := py+dy+yp ;
      x3 := yp ;
   end;
   x2 := 0.0 ;
   lx := 0 ;   // Ps̉sNZ
   ll := 0 ;   // s
   al := 1 ;   // Align
   sf := 'lr SVbN';
   sm := DEFAULT_CHARSET ;
   sh := 13 ;
   sc := 0 ;
   sa := 0 ;
   i := 1 ;
   while (i <= Length(st)) do begin
      s := Copy(st,i,1);
      if (s = '\') then begin
         Inc(i);
         s := Copy(st,i,1);
         if (s = 'A') then begin
            Inc(i);
            s := Copy(st,i,1);
            al:= SInt(s);
            Case (al) of
            1: x2 := 0.0 ;  // 
            2: x2 := x3/2.0 - swa[ll]/2.0 ;  // 
            3: x2 := x3     - swa[ll] ;      // E
            end;
         end
         else if (s = 'K') then begin
            ss := '' ;
            while (i < Length(st)) do begin
               Inc(i);
               s := Copy(st,i,1);
               if (s = ';')or(s = '\') then break
               else ss := ss + s ;
            end;
            j := SInt(ss);
            if (j >= 0)and(j <= 1638) then begin
               // Cfg
               lx := lx + j ; // Cfg
               x2 := x2 + Int(j*25.4/pd*100.0)/100.0 ;
               //
               j  := gp.G_TextWidth2(sa,sh,sm,sf,'E');
               k  := sh ;
               lx := lx + j ;
               DisplayDocumentSub(dir,sc,sa,sm,k,j,x1,x2,y1,pd,sf,'E',t);
               x2 := x2 + Int(j*25.4/pd*100.0)/100.0 ;
            end;
         end
         else if (s = 'N') then begin
            // s
            Inc(ll) ;
            Case (al) of
            1: x2 := 0.0 ;  // 
            2: x2 := x3/2.0 - swa[ll]/2.0 ;  // 
            3: x2 := x3     - swa[ll] ;      // E
            end;
            if (dir = 1) then begin
               y1 := y1 - Int(sha[ll]*25.4/pd*100.0)/100.0 - pl ;
            end
            else begin
               x1 := x1 - Int(sha[ll]*25.4/pd*100.0)/100.0 - pl ;
            end;
            lx := 0 ;
         end
         else if (s = 'T') then begin
            // TAB
            j  := lx ;
            lx := ((lx div 36) + 1) * 36 ;
            j  := lx - j ;
            x2 := x2 + Int(j*25.4/pd*100.0)/100.0 ;
         end
         else if (s = 'F') then begin
            ss := '' ;
            while (i < Length(st)) do begin
               Inc(i);
               s := Copy(st,i,1);
               if (s = ';')or(s = '\') then break
               else ss := ss + s ;
            end;
            sf := ss ;
         end
         else if (s = 'M') then begin
            ss := '' ;
            while (i < Length(st)) do begin
               Inc(i);
               s := Copy(st,i,1);
               if (s = ';')or(s = '\') then break
               else ss := ss + s ;
            end;
            j := SInt(ss);
            if (j >= 0)and(j <= 255) then begin
               sm := j ;
            end;
         end
         else if (s = 'H') then begin
            ss := '' ;
            while (i < Length(st)) do begin
               Inc(i);
               s := Copy(st,i,1);
               if (s = ';')or(s = '\') then break
               else ss := ss + s ;
            end;
            j := SInt(ss);
            if (j >= 1)and(j <= 1638) then begin
               sh := j ;
            end;
         end
         else if (s = 'C') then begin
            Inc(i);
            s := Copy(st,i,6);
            i := i + 5 ;
            j := SInt('$'+s);
            if (j >= $000000)and(j <= $ffffff) then begin
               sc := j ;
            end;
         end
         else if (s = 'B') then sa := sa or 1
         else if (s = 'b') then sa := sa and $fffe
         else if (s = 'I') then sa := sa or 2
         else if (s = 'i') then sa := sa and $fffd
         else if (s = 'U') then sa := sa or 4
         else if (s = 'u') then sa := sa and $fffb
         else if (s = 'S') then sa := sa or 8
         else if (s = 's') then sa := sa and $fff7
         else if (s = 'c') then begin
            sa := 0 ;
         end;
      end
      else begin
         // `
         j  := gp.G_TextWidth2(sa,sh,sm,sf,s);
         k  := sh ;
         lx := lx + j ;
         DisplayDocumentSub(dir,sc,sa,sm,k,j,x1,x2,y1,pd,sf,s,t);
         x2 := x2 + Int(j*25.4/pd*100.0)/100.0 + ps ;
      end;
      Inc(i);
   end;

   swa := nil ;
   sha := nil ;
end;

// \̕\@Tu@Z̕\
procedure DisplayTableSub(al:integer; px1,py1,px2,py2,ps:double; fo,st:string; t:TMatrix);
var
   l1,i,ix,iy : integer ;
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   ma,mar,mx,my,mw,w1,w2,w3,wx,wy : double ;
   // pt : array of TPointD ;
   s1 : string ;
begin
   l1 := Length(st);    // 
   if (l1 = 0) then exit ;

   // --- ZENbsO`FbN ---
   MtxXY(x1,y1, px1,py2, t);  // 
   MtxXY(x2,y2, px2,py2, t);  // E
   MtxXY(x3,y3, px1,py1, t);  // 
   MtxXY(x4,y4, px2,py1, t);  // E
   // }ɂό`镶`Aό`Ȃ悤K
   ma := dAngle((x2-x1),(y2-y1));   // ̊px
   mx := Dist(x1,y1, x2,y2);        // ͈͕
   my := Dist(x1,y1, x3,y3);        // ͈͍
   w1 := dAngle((x3-x1),(y3-y1)) - ma ;
   my := Abs(my*Sin(w1/180.0*Pi));  // VE͈͍
   //
   mar:= ma/180.0*Pi;
   x3 := x1+my*Cos(mar+0.5*Pi);
   y3 := y1+my*Sin(mar+0.5*Pi);
   x4 := x2+my*Cos(mar+0.5*Pi);
   y4 := y2+my*Sin(mar+0.5*Pi);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   // eXg\(FULL-BOX)
{
   SetLength(pt,5);
   pt[0].x := x1; pt[0].y := y1;
   pt[1].x := x2; pt[1].y := y2;
   pt[2].x := x4; pt[2].y := y4;
   pt[3].x := x3; pt[3].y := y3;
   pt[4].x := x1; pt[4].y := y1;
   DisplayPolygon(4,pt);
   pt := nil;
}
   i := gp.G_TextWidth2(0,100,DEFAULT_CHARSET,fo,st);
   w1 := my*i/100.0 + (l1-1.0)*ps ;
   if (w1 < mx) then begin
      Case(al)of
      2: begin
            wx := x3 + (mx-w1)/2.0*Cos(mar) ;
            wy := y3 + (mx-w1)/2.0*Sin(mar) ;
         end;
      3: begin
            wx := x3 + (mx-w1)*Cos(mar) ;
            wy := y3 + (mx-w1)*Sin(mar) ;
         end;
      else begin
            wx := x3 ;
            wy := y3 ;
         end;
      end;
      mx := w1 ;
   end
   else begin
      wx := x3 ;
      wy := y3 ;
   end;

   w1 := 0.0;
   w2 := gp.G_TextWidth(0,32,32,fo,st);
   mw := mx - (l1-1.0)*ps ;
   for i:=1 to l1 do begin
      s1 := Copy(st,i,1);
      w3 := gp.G_TextWidth(0,32,32,fo,s1) / w2 ;
      // 1Pʂ̃NbsO`FbN
      x1 := wx+w1*Cos(mar);
      y1 := wy+w1*Sin(mar);
      x2 := wx+(w1+mw*w3)*Cos(mar);
      y2 := wy+(w1+mw*w3)*Sin(mar);
      x3 := x1+my*Cos(mar+0.5*Pi);
      y3 := y1+my*Sin(mar+0.5*Pi);
      x4 := x2+my*Cos(mar+0.5*Pi);
      y4 := y2+my*Sin(mar+0.5*Pi);
      if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) < 2) then begin
         Z2D(ix,iy, x1,y1);
         gp.G_Text1(0,ix,iy,Round(my*mm_dot),Round(mw*w3*mm_dot),ma,0.0,fo,s1);
      end;
      w1 := w1 + mw*w3 + ps;
   end;
end;

// \̕\
procedure DisplayTable(lay,bp,co1,ro1,co2,ro2,lco,llt,lwd,cc1,fl1,cc2,fl2,tco,fnt:integer; px,py,pg,ps:double;cw,rh:array of double;al:array of Integer; st,ca:TStrGrid;t:TMatrix);
var
   i,j : integer ;
   tx,ty,fx,fy,sx,sy : double ;
   x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   idx,c,cc : integer ;
   pt : array of TPointD ;
   fo,s1 : string ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // \̊O`擾
   tx := 0.0;
   ty := 0.0;
   fx := 0.0;  // ŒZ
   fy := 0.0;  // ŒZc
   for i:=0 to co2-1 do begin
      tx := tx + cw[i] ;
      fx := fx + cw[i] ;
   end;
   for i:=co2 to co1-1 do begin
      tx := tx + cw[i] ;
   end;
   for i:=0 to ro2-1 do begin
      ty := ty + rh[i] ;
      fy := fy + rh[i] ;
   end;
   for i:=ro2 to ro1-1 do begin
      ty := ty + rh[i] ;
   end;

   // \̈ʒui:sx,syj
   case(bp)of
   1: begin   // 1:
         sx := px ;
         sy := py + ty ;
      end;
   2: begin   // 2:
         sx := px - tx/2.0 ;
         sy := py + ty ;
      end;
   3: begin   // 3:E
         sx := px - tx ;
         sy := py + ty ;
      end;
   4: begin   // 4:
         sx := px ;
         sy := py + ty/2.0 ;
      end;
   5: begin   // 5:
         sx := px - tx/2.0 ;
         sy := py + ty/2.0 ;
      end;
   6: begin   // 6:E
         sx := px - tx ;
         sy := py + ty/2.0 ;
      end;
   8: begin   // 8:
         sx := px - tx/2.0 ;
         sy := py ;
      end;
   9: begin   // 9:E
         sx := px - tx ;
         sy := py ;
      end;
   else begin // 7:
         sx := px ;
         sy := py ;
      end;
   end;

   // NbsO`FbN
   x1 := sx;      y1 := sy;      MtxXY(x1,y1, x1,y1, t);
   x2 := sx;      y2 := sy-ty;   MtxXY(x2,y2, x2,y2, t);
   x3 := sx+tx;   y3 := sy-ty;   MtxXY(x3,y3, x3,y3, t);
   x4 := sx+tx;   y4 := sy;      MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   // Z̓hׂ
   if (fl1 <> 0)and(co1 > co2)and(ro1 > ro2) then begin
      DisplayLayCol1(lay,cc1,c,cc);    // F
      gp.G_SetWidth(1);
      SetLength(pt,5);
      MtxXY(pt[0].x,pt[0].y, sx+fx,sy-fy, t);
      MtxXY(pt[1].x,pt[1].y, sx+tx,sy-fy, t);
      MtxXY(pt[2].x,pt[2].y, sx+tx,sy-ty, t);
      MtxXY(pt[3].x,pt[3].y, sx+fx,sy-ty, t);
      pt[4].x := pt[0].x ;
      pt[4].y := pt[0].y ;
      DisplayPolygon(4,pt);
      for i:=0 to 3 do
         DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
      pt := nil;
   end;
   // ŒZ̓hׂ
   if (fl2 <> 0)and(co2 > 0)and(ro2 > 0) then begin
      DisplayLayCol1(lay,cc2,c,cc);    // F
      gp.G_SetWidth(1);
      SetLength(pt,7);
      MtxXY(pt[0].x,pt[0].y, sx   ,sy   , t);
      MtxXY(pt[1].x,pt[1].y, sx+tx,sy   , t);
      MtxXY(pt[2].x,pt[2].y, sx+tx,sy-fy, t);
      MtxXY(pt[3].x,pt[3].y, sx+fx,sy-fy, t);
      MtxXY(pt[4].x,pt[4].y, sx+fx,sy-ty, t);
      MtxXY(pt[5].x,pt[5].y, sx   ,sy-ty, t);
      pt[6].x := pt[0].x ;
      pt[6].y := pt[0].y ;
      DisplayPolygon(6,pt);
      for i:=0 to 5 do
         DisplayLineSub1(pt[i].x,pt[i].y, pt[i+1].x,pt[i+1].y);
      pt := nil;
   end;

   // r 
   x1 := sx;      y1 := sy;
   x2 := sx+tx;   y2 := y1;
   MtxXY(x3,y3, x1,y1, t);
   MtxXY(x4,y4, x2,y2, t);
   DisplayLine(lay,lco,llt,lwd, x3,y3,x4,y4);
   for i:=0 to ro1-1 do begin
      y1 := y1 - rh[i] ;
      y2 := y1 ;
      MtxXY(x3,y3, x1,y1, t);
      MtxXY(x4,y4, x2,y2, t);
      DisplayLine(lay,lco,llt,lwd, x3,y3,x4,y4);
   end;
   // r c
   x1 := sx;   y1 := sy;
   x2 := x1;   y2 := sy-ty;
   MtxXY(x3,y3, x1,y1, t);
   MtxXY(x4,y4, x2,y2, t);
   DisplayLine(lay,lco,llt,lwd, x3,y3,x4,y4);
   for i:=0 to co1-1 do begin
      x1 := x1 + cw[i] ;
      x2 := x1 ;
      MtxXY(x3,y3, x1,y1, t);
      MtxXY(x4,y4, x2,y2, t);
      DisplayLine(lay,lco,llt,lwd, x3,y3,x4,y4);
   end;

   // 
   if (fnt = 0) then begin
      idx := CData.GetLayerIdx(lay);
      if (idx = -1) then begin
         idx := CData.GetLayerIdx(1);
         if (idx = -1) then idx := 0;
      end;
      fnt := CData.zLay[idx].Mfont ;
   end;
   idx := CData.GetFontIdx(fnt);
   if (idx = -1) then begin
      idx := CData.GetFontIdx(1);
      if (idx = -1) then idx := 0;
   end;
   fo := CData.zFnt[idx].name ;   // tHg
   s1 := Copy(fo,1,1);
   if (s1 = '@')or(s1 = '') then fo := Copy(fo,2,Length(fo));

   DisplayLayCol1(lay,tco,c,cc);    // F
   gp.G_SetWidth(1);

   y1 := sy ;
   for j:=0 to ro1-1 do begin
      x1 := sx ;
      for i:=0 to co1-1 do begin
         if (st[i,j] <> '') then
            DisplayTableSub(al[i], x1+pg,y1-pg, x1+cw[i]-pg,y1-rh[j]+pg, ps, fo,st[i,j], t);

         x1 := x1 + cw[i] ;
      end;
      y1 := y1 - rh[j] ;
   end;
end;

// @̕\
procedure DisplayDimLine(lay,col,ltp,wid,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
var
   lx1,ly1,lx2,ly2,lx3,ly3, a,aa : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   a := dAngle((sx2-sx1),(sy2-sy1));
   // @
   MtxXY(lx1,ly1, sx1,sy1, t);
   MtxXY(lx2,ly2, sx2,sy2, t);
   DisplayLine(lay,col,ltp,wid, lx1,ly1,lx2,ly2);
   // ⏕P
   if (f2 = 1) then begin
      MtxXY(lx1,ly1, h1x1,h1y1, t);
      MtxXY(lx2,ly2, h1x2,h1y2, t);
      DisplayLine(lay,col,ltp,wid, lx1,ly1,lx2,ly2);
   end;
   // ⏕Q
   if (f3 = 1) then begin
      MtxXY(lx1,ly1, h2x1,h2y1, t);
      MtxXY(lx2,ly2, h2x2,h2y2, t);
      DisplayLine(lay,col,ltp,wid, lx1,ly1,lx2,ly2);
   end;
   // P
   if (ar12 = 2) then
      aa := a/180.0*Pi
   else
      aa := (a+180.0)/180.0*Pi ;
   if (ar12 > 0) then begin
      MtxXY(lx1,ly1, ar1x,ar1y, t);
      lx2 := ar1x + 10.0*Cos(aa);
      ly2 := ar1y + 10.0*Sin(aa);
      MtxXY(lx3,ly3, lx2,ly2, t);
      aa  := Angle(lx3-lx1,ly3-ly1);
      DisplayArrow(lay,col,ar11,lx1,ly1,aa,ar1r);
   end;
   // Q
   if (ar22 = 2) then
      aa := (a+180.0)/180.0*Pi
   else
      aa := a/180.0*Pi ;
   if (ar22 > 0) then begin
      MtxXY(lx1,ly1, ar2x,ar2y, t);
      lx2 := ar2x + 10.0*Cos(aa);
      ly2 := ar2y + 10.0*Sin(aa);
      MtxXY(lx3,ly3, lx2,ly2, t);
      aa  := Angle(lx3-lx1,ly3-ly1);
      DisplayArrow(lay,col,ar21,lx1,ly1,aa,ar2r);
   end;
   // @l
   if (f4 = 1) then begin
      DisplayText(lay,col,fnt,bp,dir, tx,ty,th,tw,ts,an,sl,st,t);
   end;
end;

// ʒ@̕\
procedure DisplayDimArc(lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
begin
   DisplayDimAngle(lay,col,ltp,wid,sp,f2,f3,f4, ar11,ar12,ar21,ar22,fnt,bp,dir,
               sx,sy,sr,sa0,sa1,
               h1x0,h1y0,h1x1,h1y1,h1x2,h1y2,
               h2x0,h2y0,h2x1,h2y1,h2x2,h2y2,
               ar1x,ar1y,ar1r, ar2x,ar2y,ar2r,
               tx,ty,th,tw,ts,an,sl,st,
               t);
end;

// px@̕\
procedure DisplayDimAngle(lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
var
   lx1,ly1,lx2,ly2,lx3,ly3, aa : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // @
   DisplayArc(lay,col,ltp,wid,sp, 0, sx,sy,sr,sa0,sa1,t);
   // ⏕P
   if (f2 = 1) then begin
      MtxXY(lx1,ly1, h1x1,h1y1, t);
      MtxXY(lx2,ly2, h1x2,h1y2, t);
      DisplayLine(lay,col,ltp,wid, lx1,ly1,lx2,ly2);
   end;
   // ⏕Q
   if (f3 = 1) then begin
      MtxXY(lx1,ly1, h2x1,h2y1, t);
      MtxXY(lx2,ly2, h2x2,h2y2, t);
      DisplayLine(lay,col,ltp,wid, lx1,ly1,lx2,ly2);
   end;
   // P
   aa := dAngle(ar1x-sx,ar1y-sy);
   if (ar12 = 2) then
      aa := (aa+5.0)/180.0*Pi
   else
      aa := (aa-5.0)/180.0*Pi ;
   if (ar12 > 0) then begin
      MtxXY(lx1,ly1, ar1x,ar1y, t);
      lx2 := sx + sr*Cos(aa);
      ly2 := sy + sr*Sin(aa);
      MtxXY(lx3,ly3, lx2,ly2, t);
      aa  := Angle(lx3-lx1,ly3-ly1);
      DisplayArrow(lay,col,ar11,lx1,ly1,aa,ar1r);
   end;
   // Q
   aa := dAngle(ar2x-sx,ar2y-sy);
   if (ar22 = 2) then
      aa := (aa-5.0)/180.0*Pi
   else
      aa := (aa+5.0)/180.0*Pi ;
   if (ar22 > 0) then begin
      MtxXY(lx1,ly1, ar2x,ar2y, t);
      lx2 := sx + sr*Cos(aa);
      ly2 := sy + sr*Sin(aa);
      MtxXY(lx3,ly3, lx2,ly2, t);
      aa  := Angle(lx3-lx1,ly3-ly1);
      DisplayArrow(lay,col,ar21,lx1,ly1,aa,ar2r);
   end;
   // @l
   if (f4 = 1) then begin
      DisplayText(lay,col,fnt,bp,dir, tx,ty,th,tw,ts,an,sl,st,t);
   end;
end;

// a@̕\
procedure DisplayDimRadius(lay,col,ltp,wid,fl,ar1,ar2,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, arx,ary,arr, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
var
   lx1,ly1,lx2,ly2,lx3,ly3, a,aa : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   a := dAngle((sx2-sx1),(sy2-sy1));
   // @
   MtxXY(lx1,ly1, sx1,sy1, t);
   MtxXY(lx2,ly2, sx2,sy2, t);
   DisplayLine(lay,col,ltp,wid, lx1,ly1,lx2,ly2);
   // 
   if (ar2 = 1) then
      aa := a/180.0*Pi
   else
      aa := (a+180.0)/180.0*Pi ;
   if (ar2 > 0) then begin
      MtxXY(lx1,ly1, arx,ary, t);
      lx2 := arx + 10.0*Cos(aa);
      ly2 := ary + 10.0*Sin(aa);
      MtxXY(lx3,ly3, lx2,ly2, t);
      aa  := Angle(lx3-lx1,ly3-ly1);
      DisplayArrow(lay,col,ar1,lx1,ly1,aa,arr);
   end;
   // @l
   if (fl = 1) then begin
      DisplayText(lay,col,fnt,bp,dir, tx,ty,th,tw,ts,an,sl,st,t);
   end;
end;

// a@̕\
procedure DisplayDimDiameter(lay,col,ltp,wid,fl,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
var
   lx1,ly1,lx2,ly2,lx3,ly3, a,aa : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   a := dAngle((sx2-sx1),(sy2-sy1));
   // @
   MtxXY(lx1,ly1, sx1,sy1, t);
   MtxXY(lx2,ly2, sx2,sy2, t);
   DisplayLine(lay,col,ltp,wid, lx1,ly1,lx2,ly2);
   // P
   if (ar12 = 2) then
      aa := a/180.0*Pi
   else
      aa := (a+180.0)/180.0*Pi ;
   if (ar12 > 0) then begin
      MtxXY(lx1,ly1, ar1x,ar1y, t);
      lx2 := ar1x + 10.0*Cos(aa);
      ly2 := ar1y + 10.0*Sin(aa);
      MtxXY(lx3,ly3, lx2,ly2, t);
      aa  := Angle(lx3-lx1,ly3-ly1);
      DisplayArrow(lay,col,ar11,lx1,ly1,aa,ar1r);
   end;
   // Q
   if (ar22 = 2) then
      aa := (a+180.0)/180.0*Pi
   else
      aa := a/180.0*Pi ;
   if (ar22 > 0) then begin
      MtxXY(lx1,ly1, ar2x,ar2y, t);
      lx2 := ar2x + 10.0*Cos(aa);
      ly2 := ar2y + 10.0*Sin(aa);
      MtxXY(lx3,ly3, lx2,ly2, t);
      aa  := Angle(lx3-lx1,ly3-ly1);
      DisplayArrow(lay,col,ar21,lx1,ly1,aa,ar2r);
   end;
   // @l
   if (fl = 1) then begin
      DisplayText(lay,col,fnt,bp,dir, tx,ty,th,tw,ts,an,sl,st,t);
   end;
end;

// o̕\
procedure DisplayDimLeader(lay,col,ltp,wid,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double; arr, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
var
   x1,y1,x2,y2,aa : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // @
   DisplayLines(lay,col,ltp,wid,num, vx,vy,t);
   // 
   MtxXY(x1,y1, vx[0],vy[0], t);
   MtxXY(x2,y2, vx[1],vy[1], t);
   aa := Angle(x2-x1, y2-y1);
   DisplayArrow(lay,col,ar,x1,y1,aa,arr);
   // @l
   if (fl = 1) then begin
      DisplayText(lay,col,fnt,bp,dir, tx,ty,th,tw,ts,an,sl,st,t);
   end;
end;

// o[̕\
procedure DisplayDimBalloon(lay,col,ltp,wid,sp,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double; cx,cy,cr, arr, tx,ty,th,tw,ts,an,sl:double;st:string;t:TMatrix);
var
   x1,y1,x2,y2,aa : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // ~
   DisplayCircle(lay,col,ltp,wid,sp, cx,cy,cr,t);
   // o
   DisplayLines(lay,col,ltp,wid,num, vx,vy,t);
   // 
   MtxXY(x1,y1, vx[0],vy[0], t);
   MtxXY(x2,y2, vx[1],vy[1], t);
   aa := Angle(x2-x1, y2-y1);
   DisplayArrow(lay,col,ar,x1,y1,aa,arr);
   // @l
   if (fl = 1) then begin
      DisplayText(lay,col,fnt,bp,dir, tx,ty,th,tw,ts,an,sl,st,t);
   end;
end;

// nb`O(`E[U`)̕\
procedure DisplayHatch1(lay,cf,col,oid,num,hln:integer;iid:array of integer;hl:array of THatchLine;t:TMatrix);
var
   i,j,co : integer ;
   lx1,ly1,lx2,ly2 : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // nb`O̕\
   for i:=0 to hln-1 do begin
      MtxXY(lx1,ly1, hl[i].x1,hl[i].y1, t);
      MtxXY(lx2,ly2, hl[i].x2,hl[i].y2, t);
      co := hl[i].Color ;  if (cf = 1) then co := col;
      DisplayLine(lay,co,hl[i].Ltype,hl[i].line_width, lx1,ly1,lx2,ly2);
   end;
   //
   with CData do begin
      // ꉞ`FbN
      j := CCrvIDCheck(oid);        // IDԍLǂ`FbN
      if (j = -1) then exit ;       // IDԍ
      for i:=0 to num-1 do begin
         j := CCrvIDCheck(iid[i]);  // IDԍLǂ`FbN
         if (j = -1) then exit ;    // IDԍ
      end;
      // nb`Ö}`̃Zbg
      zHArN := 1 + num ;
      SetLength(zHAr,zHArN);
      CCrvDataToHAr(oid,1);         // Ȑ` oid  Os
      j := 2 ;
      for i:=0 to num-1 do begin
         CCrvDataToHAr(iid[i],j);   // Ȑ` iid  
         Inc(j);
      end;
      // Os̕\
      j := CCrvIDCheck(oid);
      if (cDef[j].invisibility = 1) then begin
         co := cDef[j].Color ;   if (cf = 1) then co := col;
         DisplayHArLines(0,lay,co,cDef[j].Ltype,cDef[j].line_width,t) ;
      end;
      // ̕\
      for i:=0 to num-1 do begin
         j := CCrvIDCheck(iid[i]);
         if (cDef[j].invisibility = 1) then begin
            co := cDef[j].Color ;   if (cf = 1) then co := col;
            DisplayHArLines(i+1,lay,co,cDef[j].Ltype,cDef[j].line_width,t) ;
         end;
      end;
      // 
      DataClearHAr ;
   end;
end;

// nb`O(h)̕\
procedure DisplayHatch2(lay,cf,col,oid,num:integer;iid:array of integer;t:TMatrix);
var
   c,cc : integer ;
   i,j,co : integer ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   with CData do begin
      // ꉞ`FbN
      j := CCrvIDCheck(oid);        // IDԍLǂ`FbN
      if (j = -1) then exit ;       // IDԍ
      for i:=0 to num-1 do begin
         j := CCrvIDCheck(iid[i]);  // IDԍLǂ`FbN
         if (j = -1) then exit ;    // IDԍ
      end;
      // nb`Ö}`̃Zbg
      zHArN := 1 + num ;
      SetLength(zHAr,zHArN);
      CCrvDataToHAr(oid,1);         // Ȑ` oid  Os
      j := 2 ;
      for i:=0 to num-1 do begin
         CCrvDataToHAr(iid[i],j);   // Ȑ` iid  
         Inc(j);
      end;
      // h̕\
      DisplayLayCol1(lay,col,c,cc);    // F
      gp.G_SetWidth(1);
      DisplayPolygon2(t) ;
      // Os̕\
      j := CCrvIDCheck(oid);
      if (cDef[j].invisibility = 1) then begin
         co := cDef[j].Color ;   if (cf = 1) then co := col;
         DisplayHArLines(0,lay,co,cDef[j].Ltype,cDef[j].line_width,t) ;
      end;
      // ̕\
      for i:=0 to num-1 do begin
         j := CCrvIDCheck(iid[i]);
         if (cDef[j].invisibility = 1) then begin
            co := cDef[j].Color ;   if (cf = 1) then co := col;
            DisplayHArLines(i+1,lay,co,cDef[j].Ltype,cDef[j].line_width,t) ;
         end;
      end;
      // 
      DataClearHAr ;
   end;
end;

// nb`O(ߓh)̕\
procedure DisplayHatch5(lay,cf,col,al,oid,num:integer;iid:array of integer;t:TMatrix);
var
   c,cc : integer ;
   i,j,co : integer ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   with CData do begin
      // ꉞ`FbN
      j := CCrvIDCheck(oid);        // IDԍLǂ`FbN
      if (j = -1) then exit ;       // IDԍ
      for i:=0 to num-1 do begin
         j := CCrvIDCheck(iid[i]);  // IDԍLǂ`FbN
         if (j = -1) then exit ;    // IDԍ
      end;
      // nb`Ö}`̃Zbg
      zHArN := 1 + num ;
      SetLength(zHAr,zHArN);
      CCrvDataToHAr(oid,1);         // Ȑ` oid  Os
      j := 2 ;
      for i:=0 to num-1 do begin
         CCrvDataToHAr(iid[i],j);   // Ȑ` iid  
         Inc(j);
      end;
      // h̕\
      DisplayLayCol1(lay,col,c,cc);    // F cc:RGBF
      gp.G_SetWidth(1);
      DisplayPolygon3(cc,al,t) ;
      // Os̕\
      j := CCrvIDCheck(oid);
      if (cDef[j].invisibility = 1) then begin
         co := cDef[j].Color ;   if (cf = 1) then co := col;
         DisplayHArLines(0,lay,co,cDef[j].Ltype,cDef[j].line_width,t) ;
      end;
      // ̕\
      for i:=0 to num-1 do begin
         j := CCrvIDCheck(iid[i]);
         if (cDef[j].invisibility = 1) then begin
            co := cDef[j].Color ;   if (cf = 1) then co := col;
            DisplayHArLines(i+1,lay,co,cDef[j].Ltype,cDef[j].line_width,t) ;
         end;
      end;
      // 
      DataClearHAr ;
   end;
end;

// nb`O(Of[Vh)̕\
procedure DisplayHatch6(lay,cf,col1,col2,al,gtp:integer;an,hx,hy:double;oid,num:integer;iid:array of integer;t:TMatrix);
var
   c,cc1,cc2 : integer ;
   i,j,co : integer ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   with CData do begin
      // ꉞ`FbN
      j := CCrvIDCheck(oid);        // IDԍLǂ`FbN
      if (j = -1) then exit ;       // IDԍ
      for i:=0 to num-1 do begin
         j := CCrvIDCheck(iid[i]);  // IDԍLǂ`FbN
         if (j = -1) then exit ;    // IDԍ
      end;
      // nb`Ö}`̃Zbg
      zHArN := 1 + num ;
      SetLength(zHAr,zHArN);
      CCrvDataToHAr(oid,1);         // Ȑ` oid  Os
      j := 2 ;
      for i:=0 to num-1 do begin
         CCrvDataToHAr(iid[i],j);   // Ȑ` iid  
         Inc(j);
      end;
      // h̕\
      DisplayLayCol1(lay,col1,c,cc1);  // F cc1:RGBF
      DisplayLayCol1(lay,col2,c,cc2);  // F cc2:RGBF
      gp.G_SetWidth(1);
      Case(gtp)of
      0: DisplayPolygon4(cc1,cc2,al,an,t);
      1: DisplayPolygon5(cc1,cc2,al,t);
      2: DisplayPolygon6(cc1,cc2,al,hx,hy,t);
      end;
      // Os̕\
      j := CCrvIDCheck(oid);
      if (cDef[j].invisibility = 1) then begin
         co := cDef[j].Color ;   if (cf = 1) then co := col1;
         DisplayHArLines(0,lay,co,cDef[j].Ltype,cDef[j].line_width,t) ;
      end;
      // ̕\
      for i:=0 to num-1 do begin
         j := CCrvIDCheck(iid[i]);
         if (cDef[j].invisibility = 1) then begin
            co := cDef[j].Color ;   if (cf = 1) then co := col1;
            DisplayHArLines(i+1,lay,co,cDef[j].Ltype,cDef[j].line_width,t) ;
         end;
      end;
      // 
      DataClearHAr ;
   end;
end;

// nb`O(摜h)̕\
procedure DisplayHatch7(lay,cf,col:integer;fn:string;oid,num:integer;iid:array of integer;t:TMatrix);
var
   ex : string ;
   c,cc : integer ;
   i,j,co : integer ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   ex := AnsiLowerCase(ExtractFileExt(fn));
   if not(FileExists(fn))
    or((ex <> '.ico')and(ex <> '.bmp')and(ex <> '.wmf')and(ex <> '.emf')
    and(ex <> '.jpg')and(ex <> '.jpeg')and(ex <> '.png')and(ex <> '.gif')
    and(ex <> '.tif')and(ex <> '.tiff')) then begin
      // 摜t@C݂Ȃꍇ́Anb`Oihjs
      DisplayHatch2(lay,cf,col,oid,num,iid,t);
      exit;
   end;

   with CData do begin
      // ꉞ`FbN
      j := CCrvIDCheck(oid);        // IDԍLǂ`FbN
      if (j = -1) then exit ;       // IDԍ
      for i:=0 to num-1 do begin
         j := CCrvIDCheck(iid[i]);  // IDԍLǂ`FbN
         if (j = -1) then exit ;    // IDԍ
      end;
      // nb`Ö}`̃Zbg
      zHArN := 1 + num ;
      SetLength(zHAr,zHArN);
      CCrvDataToHAr(oid,1);         // Ȑ` oid  Os
      j := 2 ;
      for i:=0 to num-1 do begin
         CCrvDataToHAr(iid[i],j);   // Ȑ` iid  
         Inc(j);
      end;
      // h̕\
      DisplayLayCol1(lay,col,c,cc);    // F
      gp.G_SetWidth(1);
      DisplayPolygon7(fn,t) ;
      // Os̕\
      j := CCrvIDCheck(oid);
      if (cDef[j].invisibility = 1) then begin
         co := cDef[j].Color ;   if (cf = 1) then co := col;
         DisplayHArLines(0,lay,co,cDef[j].Ltype,cDef[j].line_width,t) ;
      end;
      // ̕\
      for i:=0 to num-1 do begin
         j := CCrvIDCheck(iid[i]);
         if (cDef[j].invisibility = 1) then begin
            co := cDef[j].Color ;   if (cf = 1) then co := col;
            DisplayHArLines(i+1,lay,co,cDef[j].Ltype,cDef[j].line_width,t) ;
         end;
      end;
      // 
      DataClearHAr ;
   end;
end;

// V{}`̕\
procedure DisplaySymbolZukei(lay,cf,col:integer;nam:string;px,py,an,sc:double;t:TMatrix);
var
   x1,y1,x2,y2,ma : double ;
   tr,tr1 : TMatrix ;
   j,k,o,o1,o2,la,co,co2,dn : integer ;
   lx1,ly1,lx2,ly2,lan,lsc : double ;
begin
   if not(CheckLayDisp(lay)) then exit ;  // \C

   // ϊsɂpx擾
   x1 :=  0.0;    y1 := 0.0;     MtxXY(x1,y1, x1,y1, t);
   x2 := 10.0;    y2 := 0.0;     MtxXY(x2,y2, x2,y2, t);
   ma := dAngle((x2-x1),(y2-y1));
   ma := ma + an ;   // V{}`̊pxZ
   // ϊsɂʒu擾
   x1 := px ;     y1 := py ;     MtxXY(x1,y1, x1,y1, t);
   // ϊs쐬iꉞ t ͏㏑Ȃ悤ɂĂj
   MtxScale(tr, sc,sc);
   MtxRotD(tr1, ma);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, x1,y1);
   tr := MtxMult(tr,tr1) ;
   //
   j := CData.FZukeiNameCheck(0,nam) ;
   if (j < 0) then begin
      with CData.sDef[-j-1] do begin
         dn := datn ;
      end;
      with CData.sDefD[dn] do begin
         for o:=0 to mOrdN-1 do begin
            o1 := mOrd[o].DataType ;
            o2 := mOrd[o].DataNo ;
            case (o1) of
            1: begin
                  // _}[JEf[^\
                  with mTen[o2] do begin
                     if not(exf) then continue ;
                     MtxXY(lx1,ly1, start_x,start_y, tr);
                     lan := (rotate_angle + ma)/180.0*Pi ;
                     lsc := Scale * sc ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayTenMarker(la,co,marker_code,lx1,ly1,lan,lsc);
                  end;
               end;
            2: begin
                  // f[^\
                  with mLin[o2] do begin
                     if not(exf) then continue ;
                     MtxXY(lx1,ly1, start_x,start_y, tr);
                     MtxXY(lx2,ly2, end_x  ,end_y  , tr);
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayLine(la,co,Ltype,line_width,lx1,ly1,lx2,ly2);
                  end;
               end;
            3: begin
                  // ܐf[^\
                  with mLns[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayLines(la,co,Ltype,line_width,Number,X,Y,tr);
                  end;
               end;
            4: begin
                  // ~f[^\
                  with mCir[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayCircle(la,co,Ltype,line_width,sep,Center_x,Center_y,Radius,tr);
                  end;
               end;
            5: begin
                  // ~ʃf[^\
                  with mArc[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayArc(la,co,Ltype,line_width,sep,Direction,Center_x,Center_y,Radius,start_angle,end_angle,tr);
                  end;
               end;
            6: begin
                  // ȉ~f[^\
                  with mEll[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayEllipse(la,co,Ltype,line_width,sep,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,tr);
                  end;
               end;
            7: begin
                  // ȉ~ʃf[^\
                  with mEAr[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayEllipseArc(la,co,Ltype,line_width,sep,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,tr);
                  end;
               end;
            8: begin
                  // f[^\
                  with mTxt[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayText(la,co,Font,b_pnt,Direct, text_x,text_y,Height,Width,Spc,Angle,Slant,str,tr);
                  end;
               end;
            9: begin
                  // xWFȐf[^\
                  with mBez[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayBezier(la,co,Ltype,line_width,sep,Number,X,Y,tr);
                  end;
               end;
            10:begin
                  // aXvCȐf[^\
                  with mBsp[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayBspline(la,co,Ltype,line_width,open_close,sep,Number,X,Y,tr);
                  end;
               end;
            11:begin
                  // XvCȐf[^\
                  with mSpl[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplaySpline(la,co,Ltype,line_width,Stype,open_close,sep,Number,Aval,X,Y,tr);
                  end;
               end;
            12:begin
                  // N\ChȐf[^\
                  with mClo[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayClothoid(la,co,Ltype,line_width,Direction,sep, base_x,base_y,Aval,Angle,start_length,end_length,tr);
                  end;
               end;
            13:begin
                  // f[^\
                  with mArw[o2] do begin
                     if not(exf) then continue ;
                     MtxXY(lx1,ly1, start_x,start_y, tr);
                     lan := (rotate_angle + ma)/180.0*Pi ;
                     lsc := Scale * sc ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayArrow(la,co,arrow_code,lx1,ly1,lan,lsc);
                  end;
               end;
            15:begin
                  // ̓f[^\
                  with mDoc[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     DisplayDocument(la,b_pnt,Direct, text_x,text_y,Dpi,Width,Spc,Lspc,Angle,str,tr);
                  end;
               end;
            16:begin
                  // \f[^\
                  with mTbl[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;        if (lay > 0) then la := lay ;
                     co := line_color ;   if (cf = 1)  then co := col ;
                     co2:= text_color ;   if (cf = 1)  then co2:= col ;
                     DisplayTable(la,b_pnt,Cols,Rows,FixCols,FixRows,
                        co,line_ltype,line_width,cell_color1,flg1,cell_color2,flg2,
                        co2,Font, start_x,start_y, Gap, Spc,
                        ColWidth,RowHeight, align, str,calc, tr);
                  end;
               end;
            101:begin
                  // @f[^\
                  with mDLn[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayDimLine(la,co,Ltype,line_width,flg2,flg3,flg4,
                        arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                        Font,b_pnt,Direct,
                        sun_x1,sun_y1,sun_x2,sun_y2,
                        ho1_x0,ho1_y0,ho1_x1,ho1_y1,ho1_x2,ho1_y2,
                        ho2_x0,ho2_y0,ho2_x1,ho2_y1,ho2_x2,ho2_y2,
                        arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,tr);
                  end;
               end;
            102:begin
                  // ʒ@f[^\
                  with mDAr[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayDimArc(la,co,Ltype,line_width,sep,flg2,flg3,flg4,
                        arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                        Font,b_pnt,Direct,
                        sun_x,sun_y,sun_radius,sun_angle0,sun_angle1,
                        ho1_x0,ho1_y0,ho1_x1,ho1_y1,ho1_x2,ho1_y2,
                        ho2_x0,ho2_y0,ho2_x1,ho2_y1,ho2_x2,ho2_y2,
                        arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,tr);
                  end;
               end;
            103:begin
                  // px@f[^\
                  with mDAn[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayDimAngle(la,co,Ltype,line_width,sep,flg2,flg3,flg4,
                        arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                        Font,b_pnt,Direct,
                        sun_x,sun_y,sun_radius,sun_angle0,sun_angle1,
                        ho1_x0,ho1_y0,ho1_x1,ho1_y1,ho1_x2,ho1_y2,
                        ho2_x0,ho2_y0,ho2_x1,ho2_y1,ho2_x2,ho2_y2,
                        arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,tr);
                  end;
               end;
            104:begin
                  // a@f[^\
                  with mDRa[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayDimRadius(la,co,Ltype,line_width,flg,
                        arr_code1,arr_code2,
                        Font,b_pnt,Direct,
                        sun_x1,sun_y1,sun_x2,sun_y2,
                        arr_x,arr_y,arr_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,tr);
                  end;
               end;
            105:begin
                  // a@f[^\
                  with mDDi[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayDimDiameter(la,co,Ltype,line_width,flg,
                        arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                        Font,b_pnt,Direct,
                        sun_x1,sun_y1,sun_x2,sun_y2,
                        arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,tr);
                  end;
               end;
            106:begin
                  // of[^\
                  with mDLe[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayDimLeader(la,co,Ltype,line_width,flg,
                        vertex_number, arr_code,
                        Font,b_pnt,Direct,
                        vertex_x,vertex_y, arr_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,tr);
                  end;
               end;
            107:begin
                  // o[f[^\
                  with mDBa[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayDimBalloon(la,co,Ltype,line_width,sep,flg,
                        vertex_number, arr_code,
                        Font,b_pnt,Direct,
                        vertex_x,vertex_y, center_x,center_y,Radius, arr_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,tr);
                  end;
               end;
            108:begin
                  // nb`Oi`jf[^\
                  with mHa1[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     DisplayHatch1(la,cf,col,out_id,Number,hln,in_id,hl,tr);
                  end;
               end;
            109:begin
                  // nb`Oihjf[^\
                  with mHa2[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayHatch2(la,cf,co,out_id,Number,in_id,tr);
                  end;
               end;
            110:begin
                  // nb`Oi[U`jf[^\
                  with mHa3[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     DisplayHatch1(la,cf,col,out_id,Number,hln,in_id,hl,tr);
                  end;
               end;
            111:begin
                  // nb`Oip^[jf[^\
                  with mHa4[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     DisplayHatch1(la,cf,col,out_id,Number,hln,in_id,hl,tr);
                  end;
               end;
            112:begin
                  // nb`Oiߓhjf[^\
                  with mHa5[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayHatch5(la,cf,co,Alpha,out_id,Number,in_id,tr);
                  end;
               end;
            113:begin
                  // nb`OiOf[Vhjf[^\
                  with mHa6[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color1;  if (cf = 1)  then co := col ;
                     co2:= Color2;  if (cf = 1)  then co2:= col ;
                     DisplayHatch6(la,cf,co,co2,Alpha,Gtype,Angle,housya_x,housya_y, out_id,Number,in_id,tr);
                  end;
               end;
            114:begin
                  // nb`Oi摜hjf[^\
                  with mHa7[o2] do begin
                     if not(exf) then continue ;
                     la := Layer ;  if (lay > 0) then la := lay ;
                     co := Color ;  if (cf = 1)  then co := col ;
                     DisplayHatch7(la,cf,co,ImgFileName,out_id,Number,in_id,tr);
                  end;
               end;
            end;
         end;
      end;
   end
   else begin
      // V{݂Ȃꍇ͕\(W=2,H=2,S=0)
      if (lay = 0) then lay := 1;
      if (cf = 0) then col := 0;
      lx2 := 2.0*Length(nam);
      DisplayText(lay,col,0,5,1, 0.0,0.0, 2.0,lx2,0.0, 0.0,0.0,nam,tr);
   end;
end;




// Sf[^\
procedure DisplayAllData ;
var
   o,o1,o2, i,j,k, dn : integer ;
   lx1,ly1,lx2,ly2,lx3,ly3 : double ;
   ang : double ;
   e : TMatrix ;
begin
   // ⏕f[^\
   k := CData.HojoColor ;
   MtxSetE(e);
   for o:=0 to CData.hOrdN-1 do begin
      o1 := CData.hOrd[o].DataType ;
      o2 := CData.hOrd[o].DataNo ;
      case (o1) of
      1: begin
            // _}[JEf[^\
            with CData.hTen[o2] do begin
               ang := rotate_angle/180.0*Pi ;
               DisplayTenMarker(Layer,k,marker_code,start_x,start_y,ang,Scale);
            end;
         end;
      2: begin
            // f[^\
            with CData.hLin[o2] do begin
               DisplayLine(Layer,k,Ltype,line_width,start_x,start_y,end_x,end_y);
            end;
         end;
      3: begin
            // ܐf[^\
            with CData.hLns[o2] do begin
               DisplayLines(Layer,k,Ltype,line_width,Number,X,Y,e);
            end;
         end;
      4: begin
            // ~f[^\
            with CData.hCir[o2] do begin
               DisplayCircle(Layer,k,Ltype,line_width,sep,Center_x,Center_y,Radius,e);
            end;
         end;
      5: begin
            // ~ʃf[^\
            with CData.hArc[o2] do begin
               DisplayArc(Layer,k,Ltype,line_width,sep,Direction,Center_x,Center_y,Radius,start_angle,end_angle,e);
            end;
         end;
      6: begin
            // ȉ~f[^\
            with CData.hEll[o2] do begin
               DisplayEllipse(Layer,k,Ltype,line_width,sep,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,e);
            end;
         end;
      7: begin
            // ȉ~ʃf[^\
            with CData.hEAr[o2] do begin
               DisplayEllipseArc(Layer,k,Ltype,line_width,sep,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,e);
            end;
         end;
      8: begin
            // f[^\
            with CData.hTxt[o2] do begin
               DisplayText(Layer,k,Font,b_pnt,Direct, text_x,text_y,Height,Width,Spc,Angle,Slant,str,e);
            end;
         end;
      end;
   end;
   // 􉽗vf^}ȉ@ef[^\
   for i:=0 to CData.zFztN-1 do begin
      j := CData.FZukeiNameCheck(0,CData.zFzt[i].name) ;
      if (j <= 0) then continue ;
      with CData.fDef[j-1] do begin
         dn := datn ;
      end;
      with CData.fDefD[dn] do begin
         for o:=0 to hOrdN-1 do begin
            o1 := hOrd[o].DataType ;
            o2 := hOrd[o].DataNo ;
            case (o1) of
            1: begin
                  // _}[JEf[^\
                  with hTen[o2] do begin
                     MtxXY(lx1,ly1, start_x,start_y, CData.zFzt[i].mtx);
                     ang := rotate_angle/180.0*Pi ;
                     lx2 := start_x + 10.0*Cos(ang);
                     ly2 := start_y + 10.0*Sin(ang);
                     MtxXY(lx3,ly3, lx2,ly2, CData.zFzt[i].mtx);
                     ang  := Angle(lx3-lx1,ly3-ly1);
                     DisplayTenMarker(Layer,k,marker_code,lx1,ly1,ang,Scale);
                  end;
               end;
            2: begin
                  // f[^\
                  with hLin[o2] do begin
                     MtxXY(lx1,ly1, start_x,start_y, CData.zFzt[i].mtx);
                     MtxXY(lx2,ly2, end_x  ,end_y  , CData.zFzt[i].mtx);
                     DisplayLine(Layer,k,Ltype,line_width,lx1,ly1,lx2,ly2);
                  end;
               end;
            3: begin
                  // ܐf[^\
                  with hLns[o2] do begin
                     DisplayLines(Layer,k,Ltype,line_width,Number,X,Y,CData.zFzt[i].mtx);
                  end;
               end;
            4: begin
                  // ~f[^\
                  with hCir[o2] do begin
                     DisplayCircle(Layer,k,Ltype,line_width,sep,Center_x,Center_y,Radius,CData.zFzt[i].mtx);
                  end;
               end;
            5: begin
                  // ~ʃf[^\
                  with hArc[o2] do begin
                     DisplayArc(Layer,k,Ltype,line_width,sep,Direction,Center_x,Center_y,Radius,start_angle,end_angle,CData.zFzt[i].mtx);
                  end;
               end;
            6: begin
                  // ȉ~f[^\
                  with hEll[o2] do begin
                     DisplayEllipse(Layer,k,Ltype,line_width,sep,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,CData.zFzt[i].mtx);
                  end;
               end;
            7: begin
                  // ȉ~ʃf[^\
                  with hEAr[o2] do begin
                     DisplayEllipseArc(Layer,k,Ltype,line_width,sep,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,CData.zFzt[i].mtx);
                  end;
               end;
            8: begin
                  // f[^\
                  with hTxt[o2] do begin
                     DisplayText(Layer,k,Font,b_pnt,Direct, text_x,text_y,Height,Width,Spc,Angle,Slant,str,CData.zFzt[i].mtx);
                  end;
               end;
            end;
         end;
      end;
   end;

   // ʏf[^\
   MtxSetE(e);
   // \Lvf^p@ef[^\
   for o:=0 to CData.dOrdN-1 do begin
      o1 := CData.dOrd[o].DataType ;
      o2 := CData.dOrd[o].DataNo ;
      case (o1) of
      1: begin
            // _}[JEf[^\
            with CData.dTen[o2] do begin
               if not(exf) then continue ;
               ang := rotate_angle/180.0*Pi ;
               DisplayTenMarker(Layer,Color,marker_code,start_x,start_y,ang,Scale);
            end;
         end;
      2: begin
            // f[^\
            with CData.dLin[o2] do begin
               if not(exf) then continue ;
               DisplayLine(Layer,Color,Ltype,line_width,start_x,start_y,end_x,end_y);
            end;
         end;
      3: begin
            // ܐf[^\
            with CData.dLns[o2] do begin
               if not(exf) then continue ;
               DisplayLines(Layer,Color,Ltype,line_width,Number,X,Y,e);
            end;
         end;
      4: begin
            // ~f[^\
            with CData.dCir[o2] do begin
               if not(exf) then continue ;
               DisplayCircle(Layer,Color,Ltype,line_width,sep,Center_x,Center_y,Radius,e);
            end;
         end;
      5: begin
            // ~ʃf[^\
            with CData.dArc[o2] do begin
               if not(exf) then continue ;
               DisplayArc(Layer,Color,Ltype,line_width,sep,Direction,Center_x,Center_y,Radius,start_angle,end_angle,e);
            end;
         end;
      6: begin
            // ȉ~f[^\
            with CData.dEll[o2] do begin
               if not(exf) then continue ;
               DisplayEllipse(Layer,Color,Ltype,line_width,sep,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,e);
            end;
         end;
      7: begin
            // ȉ~ʃf[^\
            with CData.dEAr[o2] do begin
               if not(exf) then continue ;
               DisplayEllipseArc(Layer,Color,Ltype,line_width,sep,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,e);
            end;
         end;
      8: begin
            // f[^\
            with CData.dTxt[o2] do begin
               if not(exf) then continue ;
               DisplayText(Layer,Color,Font,b_pnt,Direct, text_x,text_y,Height,Width,Spc,Angle,Slant,str,e);
            end;
         end;
      9: begin
            // xWFȐf[^\
            with CData.dBez[o2] do begin
               if not(exf) then continue ;
               DisplayBezier(Layer,Color,Ltype,line_width,sep,Number,X,Y,e);
            end;
         end;
      10:begin
            // aXvCȐf[^\
            with CData.dBsp[o2] do begin
               if not(exf) then continue ;
               DisplayBspline(Layer,Color,Ltype,line_width,open_close,sep,Number,X,Y,e);
            end;
         end;
      11:begin
            // XvCȐf[^\
            with CData.dSpl[o2] do begin
               if not(exf) then continue ;
               DisplaySpline(Layer,Color,Ltype,line_width,Stype,open_close,sep,Number,Aval,X,Y,e);
            end;
         end;
      12:begin
            // N\ChȐf[^\
            with CData.dClo[o2] do begin
               if not(exf) then continue ;
               DisplayClothoid(Layer,Color,Ltype,line_width,Direction,sep, base_x,base_y,Aval,Angle,start_length,end_length,e);
            end;
         end;
      13:begin
            // f[^\
            with CData.dArw[o2] do begin
               if not(exf) then continue ;
               ang := rotate_angle/180.0*Pi ;
               DisplayArrow(Layer,Color,arrow_code,start_x,start_y,ang,Scale);
            end;
         end;
      14:begin
            // 摜f[^\
            with CData.dImg[o2] do begin
               if not(exf) then continue ;
               DisplayImage(Layer,alpha,start_x,start_y,size_x,size_y,Angle,ImgFileName);
            end;
         end;
      15:begin
            // ̓f[^\
            with CData.dDoc[o2] do begin
               if not(exf) then continue ;
               DisplayDocument(Layer,b_pnt,Direct, text_x,text_y,Dpi,Width,Spc,Lspc,Angle,str,e);
            end;
         end;
      16:begin
            // \f[^\
            with CData.dTbl[o2] do begin
               if not(exf) then continue ;
               DisplayTable(Layer,b_pnt,Cols,Rows,FixCols,FixRows,
                  line_color,line_ltype,line_width,cell_color1,flg1,cell_color2,flg2,
                  text_color,Font, start_x,start_y, Gap, Spc,
                  ColWidth,RowHeight, align, str,calc, e);
            end;
         end;
      99:begin
            // }`zuFX[
         end;
      100:begin
            // V{}`f[^\
            with CData.dSzk[o2] do begin
               if not(exf) then continue ;
               DisplaySymbolZukei(Layer,color_flag,Color,name,start_x,start_y,rotate_angle,Scale,e);
            end;
         end;
      101:begin
            // @f[^\
            with CData.dDLn[o2] do begin
               if not(exf) then continue ;
               DisplayDimLine(Layer,Color,Ltype,line_width,flg2,flg3,flg4,
                  arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                  Font,b_pnt,Direct,
                  sun_x1,sun_y1,sun_x2,sun_y2,
                  ho1_x0,ho1_y0,ho1_x1,ho1_y1,ho1_x2,ho1_y2,
                  ho2_x0,ho2_y0,ho2_x1,ho2_y1,ho2_x2,ho2_y2,
                  arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                  text_x,text_y,Height,Width,Spc,Angle,Slant,str,e);
            end;
         end;
      102:begin
            // ʒ@f[^\
            with CData.dDAr[o2] do begin
               if not(exf) then continue ;
               DisplayDimArc(Layer,Color,Ltype,line_width,sep,flg2,flg3,flg4,
                  arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                  Font,b_pnt,Direct,
                  sun_x,sun_y,sun_radius,sun_angle0,sun_angle1,
                  ho1_x0,ho1_y0,ho1_x1,ho1_y1,ho1_x2,ho1_y2,
                  ho2_x0,ho2_y0,ho2_x1,ho2_y1,ho2_x2,ho2_y2,
                  arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                  text_x,text_y,Height,Width,Spc,Angle,Slant,str,e);
            end;
         end;
      103:begin
            // px@f[^\
            with CData.dDAn[o2] do begin
               if not(exf) then continue ;
               DisplayDimAngle(Layer,Color,Ltype,line_width,sep,flg2,flg3,flg4,
                  arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                  Font,b_pnt,Direct,
                  sun_x,sun_y,sun_radius,sun_angle0,sun_angle1,
                  ho1_x0,ho1_y0,ho1_x1,ho1_y1,ho1_x2,ho1_y2,
                  ho2_x0,ho2_y0,ho2_x1,ho2_y1,ho2_x2,ho2_y2,
                  arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                  text_x,text_y,Height,Width,Spc,Angle,Slant,str,e);
            end;
         end;
      104:begin
            // a@f[^\
            with CData.dDRa[o2] do begin
               if not(exf) then continue ;
               DisplayDimRadius(Layer,Color,Ltype,line_width,flg,
                  arr_code1,arr_code2,
                  Font,b_pnt,Direct,
                  sun_x1,sun_y1,sun_x2,sun_y2,
                  arr_x,arr_y,arr_r,
                  text_x,text_y,Height,Width,Spc,Angle,Slant,str,e);
            end;
         end;
      105:begin
            // a@f[^\
            with CData.dDDi[o2] do begin
               if not(exf) then continue ;
               DisplayDimDiameter(Layer,Color,Ltype,line_width,flg,
                  arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                  Font,b_pnt,Direct,
                  sun_x1,sun_y1,sun_x2,sun_y2,
                  arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                  text_x,text_y,Height,Width,Spc,Angle,Slant,str,e);
            end;
         end;
      106:begin
            // of[^\
            with CData.dDLe[o2] do begin
               if not(exf) then continue ;
               DisplayDimLeader(Layer,Color,Ltype,line_width,flg,
                  vertex_number, arr_code,
                  Font,b_pnt,Direct,
                  vertex_x,vertex_y, arr_r,
                  text_x,text_y,Height,Width,Spc,Angle,Slant,str,e);
            end;
         end;
      107:begin
            // o[f[^\
            with CData.dDBa[o2] do begin
               if not(exf) then continue ;
               DisplayDimBalloon(Layer,Color,Ltype,line_width,sep,flg,
                  vertex_number, arr_code,
                  Font,b_pnt,Direct,
                  vertex_x,vertex_y, center_x,center_y,Radius, arr_r,
                  text_x,text_y,Height,Width,Spc,Angle,Slant,str,e);
            end;
         end;
      108:begin
            // nb`Oi`jf[^\
            with CData.dHa1[o2] do begin
               if not(exf) then continue ;
               DisplayHatch1(Layer,0,0,out_id,Number,hln,in_id,hl,e);
            end;
         end;
      109:begin
            // nb`Oihjf[^\
            with CData.dHa2[o2] do begin
               if not(exf) then continue ;
               DisplayHatch2(Layer,0,Color,out_id,Number,in_id,e);
            end;
         end;
      110:begin
            // nb`Oi[U`jf[^\
            with CData.dHa3[o2] do begin
               if not(exf) then continue ;
               DisplayHatch1(Layer,0,0,out_id,Number,hln,in_id,hl,e);
            end;
         end;
      111:begin
            // nb`Oip^[jf[^\
            with CData.dHa4[o2] do begin
               if not(exf) then continue ;
               DisplayHatch1(Layer,0,0,out_id,Number,hln,in_id,hl,e);
            end;
         end;
      112:begin
            // nb`Oiߓhjf[^\
            with CData.dHa5[o2] do begin
               if not(exf) then continue ;
               DisplayHatch5(Layer,0,Color,Alpha,out_id,Number,in_id,e);
            end;
         end;
      113:begin
            // nb`OiOf[Vhjf[^\
            with CData.dHa6[o2] do begin
               if not(exf) then continue ;
               DisplayHatch6(Layer,0,Color1,Color2,Alpha,Gtype,Angle,housya_x,housya_y,out_id,Number,in_id,e);
            end;
         end;
      114:begin
            // nb`Oi摜hjf[^\
            with CData.dHa7[o2] do begin
               if not(exf) then continue ;
               DisplayHatch7(Layer,0,Color,ImgFileName,out_id,Number,in_id,e);
            end;
         end;
      end;
   end;

   // 􉽗vf^}ȉ@ef[^\
   for i:=0 to CData.zFztN-1 do begin
      j := CData.FZukeiNameCheck(0,CData.zFzt[i].name) ;
      if (j <= 0) then continue ;
      with CData.fDef[j-1] do begin
         dn := datn ;
      end;
      with CData.fDefD[dn] do begin
         for o:=0 to mOrdN-1 do begin
            o1 := mOrd[o].DataType ;
            o2 := mOrd[o].DataNo ;
            case (o1) of
            1: begin
                  // _}[JEf[^\
                  with mTen[o2] do begin
                     if not(exf) then continue ;
                     MtxXY(lx1,ly1, start_x,start_y, CData.zFzt[i].mtx);
                     ang := rotate_angle/180.0*Pi ;
                     lx2 := start_x + 10.0*Cos(ang);
                     ly2 := start_y + 10.0*Sin(ang);
                     MtxXY(lx3,ly3, lx2,ly2, CData.zFzt[i].mtx);
                     ang  := Angle(lx3-lx1,ly3-ly1);
                     DisplayTenMarker(Layer,Color,marker_code,lx1,ly1,ang,Scale);
                  end;
               end;
            2: begin
                  // f[^\
                  with mLin[o2] do begin
                     if not(exf) then continue ;
                     MtxXY(lx1,ly1, start_x,start_y, CData.zFzt[i].mtx);
                     MtxXY(lx2,ly2, end_x  ,end_y  , CData.zFzt[i].mtx);
                     DisplayLine(Layer,Color,Ltype,line_width,lx1,ly1,lx2,ly2);
                  end;
               end;
            3: begin
                  // ܐf[^\
                  with mLns[o2] do begin
                     if not(exf) then continue ;
                     DisplayLines(Layer,Color,Ltype,line_width,Number,X,Y,CData.zFzt[i].mtx);
                  end;
               end;
            4: begin
                  // ~f[^\
                  with mCir[o2] do begin
                     if not(exf) then continue ;
                     DisplayCircle(Layer,Color,Ltype,line_width,sep,Center_x,Center_y,Radius,CData.zFzt[i].mtx);
                  end;
               end;
            5: begin
                  // ~ʃf[^\
                  with mArc[o2] do begin
                     if not(exf) then continue ;
                     DisplayArc(Layer,Color,Ltype,line_width,sep,Direction,Center_x,Center_y,Radius,start_angle,end_angle,CData.zFzt[i].mtx);
                  end;
               end;
            6: begin
                  // ȉ~f[^\
                  with mEll[o2] do begin
                     if not(exf) then continue ;
                     DisplayEllipse(Layer,Color,Ltype,line_width,sep,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,CData.zFzt[i].mtx);
                  end;
               end;
            7: begin
                  // ȉ~ʃf[^\
                  with mEAr[o2] do begin
                     if not(exf) then continue ;
                     DisplayEllipseArc(Layer,Color,Ltype,line_width,sep,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,CData.zFzt[i].mtx);
                  end;
               end;
            8: begin
                  // f[^\
                  with mTxt[o2] do begin
                     if not(exf) then continue ;
                     DisplayText(Layer,Color,Font,b_pnt,Direct, text_x,text_y,Height,Width,Spc,Angle,Slant,str,CData.zFzt[i].mtx);
                  end;
               end;
            9: begin
                  // xWFȐf[^\
                  with mBez[o2] do begin
                     if not(exf) then continue ;
                     DisplayBezier(Layer,Color,Ltype,line_width,sep,Number,X,Y,CData.zFzt[i].mtx);
                  end;
               end;
            10:begin
                  // aXvCȐf[^\
                  with mBsp[o2] do begin
                     if not(exf) then continue ;
                     DisplayBspline(Layer,Color,Ltype,line_width,open_close,sep,Number,X,Y,CData.zFzt[i].mtx);
                  end;
               end;
            11:begin
                  // XvCȐf[^\
                  with mSpl[o2] do begin
                     if not(exf) then continue ;
                     DisplaySpline(Layer,Color,Ltype,line_width,Stype,open_close,sep,Number,Aval,X,Y,CData.zFzt[i].mtx);
                  end;
               end;
            12:begin
                  // N\ChȐf[^\
                  with mClo[o2] do begin
                     if not(exf) then continue ;
                     DisplayClothoid(Layer,Color,Ltype,line_width,Direction,sep, base_x,base_y,Aval,Angle,start_length,end_length,CData.zFzt[i].mtx);
                  end;
               end;
            13:begin
                  // f[^\
                  with mArw[o2] do begin
                     if not(exf) then continue ;
                     MtxXY(lx1,ly1, start_x,start_y, CData.zFzt[i].mtx);
                     ang := rotate_angle/180.0*Pi ;
                     lx2 := start_x + 10.0*Cos(ang);
                     ly2 := start_y + 10.0*Sin(ang);
                     MtxXY(lx3,ly3, lx2,ly2, CData.zFzt[i].mtx);
                     ang  := Angle(lx3-lx1,ly3-ly1);
                     DisplayArrow(Layer,Color,arrow_code,lx1,ly1,ang,Scale);
                  end;
               end;
            15:begin
                  // ̓f[^\
                  with mDoc[o2] do begin
                     if not(exf) then continue ;
                     DisplayDocument(Layer,b_pnt,Direct, text_x,text_y,Dpi,Width,Spc,Lspc,Angle,str,CData.zFzt[i].mtx);
                  end;
               end;
            16:begin
                  // \f[^\
                  with mTbl[o2] do begin
                     if not(exf) then continue ;
                     DisplayTable(Layer,b_pnt,Cols,Rows,FixCols,FixRows,
                        line_color,line_ltype,line_width,cell_color1,flg1,cell_color2,flg2,
                        text_color,Font, start_x,start_y, Gap, Spc,
                        ColWidth,RowHeight, align, str,calc, CData.zFzt[i].mtx);
                  end;
               end;
            99:begin
                  // }`zuFX[
               end;
            100:begin
                  // V{}`f[^\
                  with mSzk[o2] do begin
                     if not(exf) then continue ;
                     DisplaySymbolZukei(Layer,color_flag,Color,name,start_x,start_y,rotate_angle,Scale,CData.zFzt[i].mtx);
                  end;
               end;
            101:begin
                  // @f[^\
                  with mDLn[o2] do begin
                     if not(exf) then continue ;
                     DisplayDimLine(Layer,Color,Ltype,line_width,flg2,flg3,flg4,
                        arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                        Font,b_pnt,Direct,
                        sun_x1,sun_y1,sun_x2,sun_y2,
                        ho1_x0,ho1_y0,ho1_x1,ho1_y1,ho1_x2,ho1_y2,
                        ho2_x0,ho2_y0,ho2_x1,ho2_y1,ho2_x2,ho2_y2,
                        arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,CData.zFzt[i].mtx);
                  end;
               end;
            102:begin
                  // ʒ@f[^\
                  with mDAr[o2] do begin
                     if not(exf) then continue ;
                     DisplayDimArc(Layer,Color,Ltype,line_width,sep,flg2,flg3,flg4,
                        arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                        Font,b_pnt,Direct,
                        sun_x,sun_y,sun_radius,sun_angle0,sun_angle1,
                        ho1_x0,ho1_y0,ho1_x1,ho1_y1,ho1_x2,ho1_y2,
                        ho2_x0,ho2_y0,ho2_x1,ho2_y1,ho2_x2,ho2_y2,
                        arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,CData.zFzt[i].mtx);
                  end;
               end;
            103:begin
                  // px@f[^\
                  with mDAn[o2] do begin
                     if not(exf) then continue ;
                     DisplayDimAngle(Layer,Color,Ltype,line_width,sep,flg2,flg3,flg4,
                        arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                        Font,b_pnt,Direct,
                        sun_x,sun_y,sun_radius,sun_angle0,sun_angle1,
                        ho1_x0,ho1_y0,ho1_x1,ho1_y1,ho1_x2,ho1_y2,
                        ho2_x0,ho2_y0,ho2_x1,ho2_y1,ho2_x2,ho2_y2,
                        arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,CData.zFzt[i].mtx);
                  end;
               end;
            104:begin
                  // a@f[^\
                  with mDRa[o2] do begin
                     if not(exf) then continue ;
                     DisplayDimRadius(Layer,Color,Ltype,line_width,flg,
                        arr_code1,arr_code2,
                        Font,b_pnt,Direct,
                        sun_x1,sun_y1,sun_x2,sun_y2,
                        arr_x,arr_y,arr_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,CData.zFzt[i].mtx);
                  end;
               end;
            105:begin
                  // a@f[^\
                  with mDDi[o2] do begin
                     if not(exf) then continue ;
                     DisplayDimDiameter(Layer,Color,Ltype,line_width,flg,
                        arr1_code1,arr1_code2,arr2_code1,arr2_code2,
                        Font,b_pnt,Direct,
                        sun_x1,sun_y1,sun_x2,sun_y2,
                        arr1_x,arr1_y,arr1_r, arr2_x,arr2_y,arr2_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,CData.zFzt[i].mtx);
                  end;
               end;
            106:begin
                  // of[^\
                  with mDLe[o2] do begin
                     if not(exf) then continue ;
                     DisplayDimLeader(Layer,Color,Ltype,line_width,flg,
                        vertex_number, arr_code,
                        Font,b_pnt,Direct,
                        vertex_x,vertex_y, arr_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,CData.zFzt[i].mtx);
                  end;
               end;
            107:begin
                  // o[f[^\
                  with mDBa[o2] do begin
                     if not(exf) then continue ;
                     DisplayDimBalloon(Layer,Color,Ltype,line_width,sep,flg,
                        vertex_number, arr_code,
                        Font,b_pnt,Direct,
                        vertex_x,vertex_y, center_x,center_y,Radius, arr_r,
                        text_x,text_y,Height,Width,Spc,Angle,Slant,str,CData.zFzt[i].mtx);
                  end;
               end;
            108:begin
                  // nb`Oi`jf[^\
                  with mHa1[o2] do begin
                     if not(exf) then continue ;
                     DisplayHatch1(Layer,0,0,out_id,Number,hln,in_id,hl,CData.zFzt[i].mtx);
                  end;
               end;
            109:begin
                  // nb`Oihjf[^\
                  with mHa2[o2] do begin
                     if not(exf) then continue ;
                     DisplayHatch2(Layer,0,Color,out_id,Number,in_id,CData.zFzt[i].mtx);
                  end;
               end;
            110:begin
                  // nb`Oi[U`jf[^\
                  with mHa3[o2] do begin
                     if not(exf) then continue ;
                     DisplayHatch1(Layer,0,0,out_id,Number,hln,in_id,hl,CData.zFzt[i].mtx);
                  end;
               end;
            111:begin
                  // nb`Oip^[jf[^\
                  with mHa4[o2] do begin
                     if not(exf) then continue ;
                     DisplayHatch1(Layer,0,0,out_id,Number,hln,in_id,hl,CData.zFzt[i].mtx);
                  end;
               end;
            112:begin
                  // nb`Oiߓhjf[^\
                  with mHa5[o2] do begin
                     if not(exf) then continue ;
                     DisplayHatch5(Layer,0,Color,Alpha,out_id,Number,in_id,CData.zFzt[i].mtx);
                  end;
               end;
            113:begin
                  // nb`OiOf[Vhjf[^\
                  with mHa6[o2] do begin
                     if not(exf) then continue ;
                     DisplayHatch6(Layer,0,Color1,Color2,Alpha,Gtype,Angle,housya_x,housya_y, out_id,Number,in_id,CData.zFzt[i].mtx);
                  end;
               end;
            114:begin
                  // nb`Oi摜hjf[^\
                  with mHa7[o2] do begin
                     if not(exf) then continue ;
                     DisplayHatch7(Layer,0,Color,ImgFileName,out_id,Number,in_id,CData.zFzt[i].mtx);
                  end;
               end;
            end;
         end;
      end;
   end;
end;


end.
